<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xslt/java" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" extension-element-prefixes="redirect" exclude-result-prefixes="sc sp java">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:variable name="vExcludedItemsSgn">(@sfileany_und|@sfile_doc_docx|@sfile_eWeb|@sfile_flv|@sfile_gif|@sfile_jpg_jpeg|@sfile_m4a|@sfile_mp3|@sfile_mp4_f4v|@sfile_odf|@sfile_odg|@sfile_odp|@sfile_ods|@sfile_odt|@sfile_oga_ogg|@sfile_ogv|@sfile_pdf|@sfile_png|@sfile_ppt_pps_pptx_ppsx|@sfile_rtf|@sfile_swf|@sfile_webm|@sfile_xls_xlsx|@sfile_xml|@sfile_zip)\b.*</xsl:variable>
	<xsl:variable name="vExcludedItemsTypes">sfileany_und|sfile_doc_docx|sfile_eWeb|sfile_flv|sfile_gif|sfile_jpg_jpeg|sfile_m4a|sfile_mp3|sfile_mp4_f4v|sfile_odf|sfile_odg|sfile_odp|sfile_ods|sfile_odt|sfile_oga_ogg|sfile_ogv|sfile_pdf|sfile_png|sfile_ppt_pps_pptx_ppsx|sfile_rtf|sfile_swf|sfile_webm|sfile_xls_xlsx|sfile_xml|sfile_zip</xsl:variable>
	<xsl:template match="*">
		<xsl:variable name="vRequest">
			<redirect:serialize omit-xml-declaration="yes" method="xml">
				<where>
					<exp uiCrit="critSrcScope" type="LinkDesc" path="{java:getSrcUri(srcFileAgent())}"/>
					<not uiOp="or">
						<exp type="ItemSgnRegexp" uiCrit="critItemType" regexpSgn="{$vExcludedItemsSgn}" uiTypes="{$vExcludedItemsTypes}"/>
					</not>
				</where>
			</redirect:serialize>
		</xsl:variable>
		<xsl:value-of select="execute(initBuffer('ctrlUrl',java:java.util.HashSet.new()))"/>
		<xsl:value-of select="getContent(currentModel(), 'ctrlUrl')" disable-output-escaping="yes"/>
		<xsl:for-each select="searchAgents($vRequest, 'ctrlUrl')">
			<xsl:value-of select="getContent(codeAgent(.))" disable-output-escaping="yes"/>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>