<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:java="http://xml.apache.org/xslt/java" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:content="http://purl.org/rss/1.0/modules/content/" xmlns:of="scpf.org:office" exclude-result-prefixes="sc sp java of">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="*">
		<xsl:variable name="vUrlPage" select="computeStrDialog('.', concat('lookFor:computeResultWithArguments=act:&amp;codeAgentPrinc=', escapeQueryString(codeAgent(concat('@', switchAxis(codeAgent('//'), 'nav'))))))"/>
		<xsl:variable name="vUrlBase" select="returnFirst(normalize-space(getContent(rootModel(),'rssUrl')),'RSS-URL-CHANGEME')"/>
		<xsl:variable name="vDate" select="of:postM/sp:date"/>
		<item>
			<title>
				<xsl:value-of select="returnFirst(getFullTitleText(currentModel()),getShortTitleText(currentModel()))"/>
			</title>
			<link>
				<xsl:value-of select="concat($vUrlBase,'/co/',$vUrlPage)"/>
			</link>
			<xsl:if test="string-length($vDate)&gt;0">
				<pubDate>
					<xsl:call-template name="timestamp">
						<xsl:with-param name="pCal" select="java:java.util.GregorianCalendar.new(number(substring-before($vDate, '-')), number(substring-before(substring-after($vDate, '-'), '-'))-1, number(substring-after(substring-after($vDate, '-'), '-')), 12, 0)"/>
					</xsl:call-template>
				</pubDate>
			</xsl:if>
			<xsl:for-each select="sp:content">
				<content:encoded>
					<xsl:value-of select="getContent(gotoSubModel(.), 'basic')" disable-output-escaping="yes"/>
				</content:encoded>
			</xsl:for-each>
		</item>
	</xsl:template>
	<xsl:template name="timestamp">
		<xsl:param name="pCal" select="java:java.util.GregorianCalendar.new()"/>
		<xsl:param name="pFormat">EEE, d MMM yyyy HH:mm:ss Z</xsl:param>
		<xsl:value-of select="execute(java:setTimeZone($pCal, java:java.util.TimeZone.getTimeZone('GMT')))"/>
		<xsl:variable name="vDateFormat" select="java:java.text.SimpleDateFormat.new(string($pFormat), java:java.util.Locale.new(&quot;en&quot;))"/>
		<xsl:value-of select="execute(java:setCalendar($vDateFormat, $pCal))"/>
		<xsl:value-of select="java:format($vDateFormat, java:getTime($pCal))"/>
	</xsl:template>
</xsl:stylesheet>