<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:java="http://xml.apache.org/xslt/java" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:of="scpf.org:office" extension-element-prefixes="redirect" exclude-result-prefixes="sc sp java">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="*">
		<xsl:variable name="vSearchReq">
			<redirect:serialize omit-xml-declaration="yes" method="xml">
				<where>
					<exp type="ItemSrcType" srcTypes="12"/>
					<exp type="LinkDesc" path="{java:getSrcUri(srcFileAgent())}" linkTraitFilter="!(#ref)"/>
					<and>
						<exp type="ItemSgnRegexp" regexpSgn="(@of_tag)\b.*" uiTypes="of_tag"/>
					</and>
				</where>
			</redirect:serialize>
		</xsl:variable>
		<ul class="tagList">
			<xsl:for-each select="searchAgents($vSearchReq)">
				<xsl:sort select="getFullTitleText(codeAgent(.))"/>
				<li id="{alphaHash(java:getSrcUri(srcFileAgent(.)))}">
					<a href="#" onclick="blogMgr.filterTag('{alphaHash(java:getSrcUri(srcFileAgent(.)))}'); return false;">
						<span>
							<xsl:value-of select="getFullTitleText(codeAgent(.))" disable-output-escaping="yes"/>
						</span>
					</a>
				</li>
			</xsl:for-each>
		</ul>
	</xsl:template>
</xsl:stylesheet>