<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" extension-element-prefixes="redirect" exclude-result-prefixes="sc xhtml" version="1.0">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:variable name="vMaxChar" select="number(genProp('optim.menu.cat.maxChar', '123'))"/>
	<xsl:variable name="vTitleText">
		<xsl:for-each select="//treeContent/entry">
			<xsl:value-of select="@title"/>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="vNumChar" select="string-length($vTitleText) + count(//treeContent/entry)*2"/>
	<xsl:variable name="vTruncateTitles" select="$vNumChar &gt; $vMaxChar"/>
	<xsl:variable name="vNumCat" select="count(//treeContent/entry)"/>
	<xsl:variable name="vMaxCharPerCat" select="max(12, round($vMaxChar div $vNumCat)-3)"/>
	<xsl:template match="treeContent">
		<xsl:if test="count(entry) &gt; 1">
			<ul class="outCat">
				<xsl:apply-templates/>
			</ul>
		</xsl:if>
	</xsl:template>
	<xsl:template match="entry">
		<xsl:variable name="vCLass" select="computeStrDialog(concat(@dialog, '/outlineClasses'))"/>
		<xsl:variable name="vUrl" select="computeStrDialog(string(@dialog), 'act:')"/>
		<xsl:variable name="vType" select="returnFirst(root,'ext')"/>
		<xsl:variable name="vTruncateTitle" select="$vTruncateTitles and string-length(@title) &gt; $vMaxCharPerCat"/>
		<xsl:variable name="vLbl" select="if($vTruncateTitle, concat(substring(@title,1,$vMaxCharPerCat),'…'), @title)"/>
		<xsl:variable name="vIsSel" select="containWord('current parent ancestor',@position)"/>
		<xsl:variable name="vIsLnk" select="genProp('category.menu.always.clickable-skin', 'false')='true' or (containWord('sibling uncle cousin',@position) or containWord('parent ancestor',@position) and containWord('blog',$vType))"/>
		<xsl:variable name="vTi" select="if($vIsSel, concat('Rubrique active : ', @title), if($vTruncateTitle, concat(@title, if($vType='ext',' - ')), if($vType='ext','lien externe')))"/>
		<li class="outCat_sel_{if($vIsSel, 'yes', 'no')} outCat_typ_{$vType} outCat_{if(entry,'b','l')} {$vCLass}">
			<xsl:choose>
				<xsl:when test="$vIsLnk">
					<a href="{$vUrl}" target="_self" class="outCat_i outCat_lnk">
						<xsl:if test="$vTi">
							<xsl:attribute name="title">
								<xsl:value-of select="$vTi"/>
							</xsl:attribute>
						</xsl:if>
						<span>
							<xsl:value-of select="$vLbl"/>
						</span>
					</a>
				</xsl:when>
				<xsl:otherwise>
					<span class="outCat_i">
						<xsl:if test="$vTi">
							<xsl:attribute name="title">
								<xsl:value-of select="$vTi"/>
							</xsl:attribute>
						</xsl:if>
						<span>
							<xsl:value-of select="$vLbl"/>
						</span>
					</span>
				</xsl:otherwise>
			</xsl:choose>
		</li>
	</xsl:template>
	<xsl:template match="node()"/>
</xsl:stylesheet>