/**
 * LICENCE[[
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1/CeCILL 2.O
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is kelis.fr code.
 *
 * The Initial Developer of the Original Code is 
 * samuel.monsarrat@kelis.fr
 *
 * Portions created by the Initial Developer are Copyright (C) 2011-2015
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * or the CeCILL Licence Version 2.0 (http://www.cecill.info/licences.en.html),
 * in which case the provisions of the GPL, the LGPL or the CeCILL are applicable
 * instead of those above. If you wish to allow use of your version of this file
 * only under the terms of either the GPL, the LGPL or the CeCILL, and not to allow
 * others to use your version of this file under the terms of the MPL, indicate
 * your decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL, the LGPL or the CeCILL. If you do not
 * delete the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL, the LGPL or the CeCILL.
 * ]]LICENCE
 */
 var controlMgr = scOnLoads[scOnLoads.length] = {
	fUrlList : null,
	fCheckUrlRoot : null,
	fCheckUrlLbl : null,
	fCheckUrlRootPath : "des:ul.ctrlUrlFra",
	fCheckUrlLblPath : "des:div.ctrlUrlLbl",
	fCheckUrlFilter : "none",
	fLegalSchemas : ["http:","https:","ftp:"],
	
	fStrings : [   "Aucun lien externe trouvé.","Contrôle en cours...",                              //0
	               "Ouvrir ce lien dans un navigateur...","Ouvrir cet item...",                      //2
	               "lien valide","lien en erreur",                                                   //4
	               "liens valides","liens en erreur",                                                //6
	               "lien à valider...","liens à valider...",                                         //8
	               "Montrer uniquement les liens valides","Montrer uniquement les liens en erreur",  //10
	               "lien non contrôlé","liens non contrôlés",                                        //12
	               "Montrer uniquement les liens non contrôlés"],
	
	initUrls : function (pList) {
		this.fUrlList = pList;
	},

	init : function () {
		this.xCheckUrls();
	},

	onLoad : function () {
	},

	filterUrlOnlyOk : function () {
		//alert("controlMgr.filterUrlOnlyOk()");
		if (this.fCheckUrlFilter == "ok") this.fCheckUrlFilter = "none";
		else this.fCheckUrlFilter = "ok";
		this.xUpdateUrlFilter();
	},
	
	filterUrlOnlyNok : function () {
		//alert("controlMgr.filterUrlOnlyNok()");
		if (this.fCheckUrlFilter == "nok") this.fCheckUrlFilter = "none";
		else this.fCheckUrlFilter = "nok";
		this.xUpdateUrlFilter();
	},
	
	filterUrlOnlyUnChecked : function () {
		//alert("controlMgr.filterUrlOnlyUnChecked()");
		if (this.fCheckUrlFilter == "unchecked") this.fCheckUrlFilter = "none";
		else this.fCheckUrlFilter = "unchecked";
		this.xUpdateUrlFilter();
	},
	
	xCheckUrls : function () {
		this.fCheckUrlRoot = scPaLib.findNode(this.fCheckUrlRootPath);
		if (!this.fCheckUrlRoot) return;
		this.fCheckUrlLbl = scPaLib.findNode(this.fCheckUrlLblPath);
		this.fCheckUrlLbl.fToolbar = scDynUiMgr.addElement("span", this.fCheckUrlLbl);
		this.fCheckUrlLbl.fPending = scDynUiMgr.addElement("span", this.fCheckUrlLbl);
		
		if (!this.fUrlList || this.fUrlList.length <= 1){
			scDynUiMgr.addElement("li", this.fCheckUrlRoot, "checkUrl-none").innerHTML = "<em>"+this.fStrings[0]+"</em>";
			return;
		}
		var vUrlList = {list:[],ctrl:{}};
		var vUrlItem;
		for (var i = 0; i < this.fUrlList.length; i++){
			vUrlItem = this.fUrlList[i];
			if (vUrlItem){
				for (var j=0; j<this.fLegalSchemas.length; j++){
					if (vUrlItem.url.indexOf(this.fLegalSchemas[j])==0) {
						vUrlItem.isCheckable = true;
						break;
					}
				}
				if (!vUrlList.ctrl[vUrlItem.url]) vUrlList.list[vUrlList.list.length] = vUrlList.ctrl[vUrlItem.url] = {url:vUrlItem.url,status:(vUrlItem.isCheckable?"pending":"uncheckable"),items:[{refItem:vUrlItem.refItem,refUri:vUrlItem.refUri}]};
				else vUrlList.ctrl[vUrlItem.url].items.push({refItem:vUrlItem.refItem,refUri:vUrlItem.refUri});
			}
		}
		this.fUrlList = vUrlList;
		for (var i = 0; i < vUrlList.list.length; i++){
			var vUrlItem = vUrlList.list[i];
			var vNode = vUrlItem.node = scDynUiMgr.addElement("li", this.fCheckUrlRoot, "checkUrl-"+vUrlItem.status);
			vNode.fUrlItem = vUrlItem;
			if (vUrlItem.status == "pending"){
				vNode.setAttribute("data-checkUrl", vUrlItem.url);
				vNode.setAttribute("data-checkUrl-param", '{"method":"HEAD,GET","headerList":"Content-Type,Content-Length"}');
				this.xAddBtn(vNode,"urlLnk", vUrlItem.url, vUrlItem.url, this.fStrings[2], "_blank");
				vNode.fResultLbl = scDynUiMgr.addElement("div", vNode, "checkUrl-report");
				vNode.fResultLbl.innerHTML = this.fStrings[1];
			} else {
				scDynUiMgr.addElement("span", vNode).innerHTML = vUrlItem.url;
			}
			var vItemUl = scDynUiMgr.addElement("ul", vNode, "checkUrl-itemList");
			for (var j = 0; j < vUrlItem.items.length; j++){
				var vItem = vUrlItem.items[j];
				var vItemLi = scDynUiMgr.addElement("li", vItemUl);
				this.xAddBtn(vItemLi,"urlRet", 'scenari:{"action":"openNode","refUri":"'+vItem.refItem+'"}', vItem.refUri, this.fStrings[3]);
			}
			vNode.addEventListener("checkUrlResponse", function(pEvt){controlMgr.xUpdateUrlItem(this.fUrlItem, this.getAttribute("data-checkUrl-report"))}, false);
		}
	},

	xUpdateUrlItem : function (pUrlItem, pReport) {
		try {
			if (typeof pReport == "string") pReport = this.xDeserialiseObjJs(pReport);
			//alert("controlMgr.xUpdateUrlItem() - status="+pReport.status+" desc="+pReport.desc+" url="+pUrlItem.url);
			var vStatus = pUrlItem.status = pReport.status;
			var vDesc = pReport.desc;
			var vNode = pUrlItem.node;
			this.xSwitchClass(vNode, "checkUrl-", "checkUrl-"+vStatus, false, false);
			var vHeaders = "";
			if (pReport.header && scCoLib.fDebug){
				vHeaders += " - status=" + pReport.header["status"];
				if (pReport.header["Content-Type"]) vHeaders += " - Content-Type=" + pReport.header["Content-Type"];
				if (pReport.header["Content-Length"]) vHeaders += " - Content-Length=" + pReport.header["Content-Length"];
			}
			vNode.fResultLbl.innerHTML = vDesc + vHeaders;
			this.xUpdateUrlLbl();
		} catch (e){alert(e)}
	},

	xUpdateUrlLbl : function () {
		if (!this.fCheckUrlLbl) return;
		var vCountPending = vCountUnChecked = vCountOk = vCountNok = 0;
		
		var vUrlList = this.fUrlList;
		for (var i = 0; i < vUrlList.list.length; i++){
			switch(vUrlList.list[i].status){
				case "pending":
					vCountPending++; break;
				case "uncheckable":
					vCountUnChecked++; break;
				case "ok":
					vCountOk++; break;
				default:
					vCountNok++; break;
			}
		}
		if (vCountUnChecked>0 && vCountOk==0 && vCountNok==0 || vCountUnChecked==0 && vCountOk>0 && vCountNok==0 || vCountUnChecked==0 && vCountOk==0 && vCountNok>0){
			this.fCheckUrlLbl.fToolbar.innerHTML = "";
			if (vCountOk>0) scDynUiMgr.addElement("span", this.fCheckUrlLbl.fToolbar, "checkUrl-countOk").innerHTML = vCountOk+" "+this.fStrings[(vCountOk>1?6:4)];
			if (vCountNok>0) scDynUiMgr.addElement("span", this.fCheckUrlLbl.fToolbar, "checkUrl-countNok").innerHTML = vCountNok+" "+this.fStrings[(vCountNok>1?7:5)];
			if (vCountUnChecked>0) scDynUiMgr.addElement("span", this.fCheckUrlLbl.fToolbar, "checkUrl-countUnChecked").innerHTML = vCountNok+" "+this.fStrings[(vCountUnChecked>1?13:12)];
		} else {
			if (!this.fCheckUrlFilterBtnOk){
				this.fCheckUrlLbl.fToolbar.innerHTML = "";
				this.fCheckUrlFilterBtnOk = this.xAddBtn(this.fCheckUrlLbl.fToolbar, "checkUrl-countOk", null, vCountOk+' '+this.fStrings[(vCountOk>1?6:4)], this.fStrings[10]);
				this.fCheckUrlFilterBtnOk.onclick = function() {controlMgr.filterUrlOnlyOk();};
				scDynUiMgr.addElement("span", this.fCheckUrlLbl.fToolbar).innerHTML = " - ";
				this.fCheckUrlFilterBtnNok = this.xAddBtn(this.fCheckUrlLbl.fToolbar, "checkUrl-countNok", null, vCountNok+' '+this.fStrings[(vCountNok>1?7:5)], this.fStrings[11]);
				this.fCheckUrlFilterBtnNok.onclick = function() {controlMgr.filterUrlOnlyNok();};
				scDynUiMgr.addElement("span", this.fCheckUrlLbl.fToolbar).innerHTML = " - ";
				this.fCheckUrlFilterBtnUnChecked = this.xAddBtn(this.fCheckUrlLbl.fToolbar, "checkUrl-countUnChecked", null, vCountUnChecked+' '+this.fStrings[(vCountUnChecked>1?13:12)], this.fStrings[14]);
				this.fCheckUrlFilterBtnUnChecked.onclick = function() {controlMgr.filterUrlOnlyUnChecked();};
			} else {
				this.fCheckUrlFilterBtnOk.innerHTML = '<span>' + vCountOk+' '+this.fStrings[(vCountOk>1?6:4)] + '</span>';
				this.fCheckUrlFilterBtnNok.innerHTML = '<span>' + vCountNok+' '+this.fStrings[(vCountNok>1?7:5)] + '</span>';
				this.fCheckUrlFilterBtnUnChecked.innerHTML = '<span>' + vCountUnChecked+' '+this.fStrings[(vCountUnChecked>1?13:12)] + '</span>';
			}
		}
		this.fCheckUrlLbl.fPending.innerHTML = "";
		if (vCountPending>0) {
			scDynUiMgr.addElement("span", this.fCheckUrlLbl.fPending).innerHTML = " - ";
			scDynUiMgr.addElement("span", this.fCheckUrlLbl.fPending, "checkUrl-countPending").innerHTML = vCountPending+" "+this.fStrings[(vCountPending>1?9:8)];
		}
	},

	xUpdateUrlFilter : function (xUpdateUrlFilter) {
		this.xSwitchClass(this.fCheckUrlRoot, "checkUrl-filter-", "checkUrl-filter-"+this.fCheckUrlFilter, true, false);
		if (this.fCheckUrlLbl) this.xSwitchClass(this.fCheckUrlLbl, "checkUrl-filter-", "checkUrl-filter-"+this.fCheckUrlFilter, true, false);
	},

/* === Utilities ============================================================ */
	/** controlMgr.xAddBtn : Add a HTML button to a parent node. */
	xAddBtn : function(pParent, pClassName, pUrl, pCapt, pTitle, pTarget) {
		pUrl = pUrl || "#";
		pTarget = pTarget || "_self";
		var vBtn = scDynUiMgr.addElement("a", pParent, pClassName);
		vBtn.href = pUrl;
		vBtn.target = pTarget;
		if (pTitle) vBtn.setAttribute("title", pTitle);
		if (pCapt) vBtn.innerHTML = "<span>" + pCapt + "</span>"
		return vBtn;
	},

	/** controlMgr.xDeserialiseObjJs */
	xDeserialiseObjJs : function(pStr){
		if(!pStr) return {};
		var vVal;
		eval("vVal="+pStr);
		return vVal;
	},

	/** controlMgr.xSwitchClass - replace a class name. */
	xSwitchClass : function(pNode, pClassOld, pClassNew, pAddIfAbsent, pMatchExact) {
		var vAddIfAbsent = typeof pAddIfAbsent == "undefined" ? false : pAddIfAbsent;
		var vMatchExact = typeof pMatchExact == "undefined" ? true : pMatchExact;
		var vClassName = pNode.className;
		var vReg = new RegExp("\\b"+pClassNew+"\\b");
		if (vMatchExact && vClassName.match(vReg)) return;
		var vClassFound = false;
		if (pClassOld && pClassOld != "") {
			if (vClassName.indexOf(pClassOld)==-1){
				if (!vAddIfAbsent) return;
				else if (pClassNew && pClassNew != '') pNode.className = vClassName + " " + pClassNew;
			} else {
				var vCurrentClasses = vClassName.split(' ');
				var vNewClasses = new Array();
				for (var i = 0, n = vCurrentClasses.length; i < n; i++) {
					var vCurrentClass = vCurrentClasses[i];
					if (vMatchExact && vCurrentClass != pClassOld || !vMatchExact && vCurrentClass.indexOf(pClassOld) != 0) {
						vNewClasses.push(vCurrentClasses[i]);
					} else {
						if (pClassNew && pClassNew != '') vNewClasses.push(pClassNew);
						vClassFound = true;
					}
				}
				pNode.className = vNewClasses.join(' ');
			}
		}
		return vClassFound;
	}

}
