
scCommentMgr = {
	rootNode : null, 				//root node (contains all the elments to comment).
	toolBarNode : null,				//root node of the tool bar

	model : {								
		fThreads : null				//threads as sent by the server
	}, 			

	controller : {
		fCommentMode : false,		//state of the manager
		fControlOriPathArray : null,//parsed oripath list from view (scCommentLib.OriPathArray)
		fPerms : null 				//perms structure from the server
	},

	view : null,

	svc : {
		fUser : null,			//currently logged user.
		fRequest : null, 		//internal field - request code to send
		fOriPathStr : null, 	//internal field - oripath param to send
		fText : null, 			//internal field - (encoded) text param to send
		fUnencodedText : null, 	//internal field - (unencoded) text param to send
		fXPath : null,			//internal field - xPath exclusion param to send
		fXPathNS : null,		//internal field - xpath namespace
		fTimeStamps : null,		//internal field - timestamp param to send
		fInit : false			//internal field
	},
	//
	strings : {
		turnOffLabel : "Désactiver le mode commentaire",
		turnOnLabel :  "Activer le mode commentaire",
		defaultCommentContent : "Entrer le contenu d\'un nouveau commentaire",
		deletingWarning : "Êtes-vous certain de vouloir supprimer ce commentaire ?",
		notSynchronizedWarning : "Un commentaire en cours d\'édition ne va pas être sauvegardé.\n\nSouhaitez-vous continuer ?",
		createThreadLabel : "Commenter",
		editCommentLabel : "Éditer",
		deleteLabel : "Supprimer",
		closeThreadLabel : "Clore",
		cancelLabel : "Annuler",
		answerLabel : "Répondre",
		saveLabel : "Enregistrer",
		reduceThreadLabel : "Réduire la discussion",
		maximizeThreadLabel : "Afficher la discussion",
		openThreadLabel : "Ré-ouvrir",
		synchronizationError : "La synchronisation avec le serveur Scenari a été perdue.",
		permissionError : "Vous n\'avez pas les droits pour exécuter cette action.",
		editedInScError : "Le document que vous consultez a été modifié au sein de Scenari.",
		commentStoredMessage : "Le contenu de votre commentaire a été sauvegardé localement.",
		tryAgainMessage : "Vous pouvez recommencer votre action.",
		contactAdminMessage : "Pour plus d\'information, contacter l\'administrateur de l\'entrepôt Scenari.",
		serverError : "Une erreur est survenue lors du traitement de votre requête.",
		reloadMessage : "Veuillez recharger la page pour recommencer votre action.",
		openedThreadsLabel : "%s1 fil(s) de commentaires ouvert(s) sur un total de %s2",
		browserError : "Votre navigateur n\'est pas compatible avec le système de commentaires Scenari. Ce dernier a été désactivé. Veuillez ouvrir la page dans un navigateur plus récent pour en bénéficier.",
		commentsMode: "Parcourir les commentaires",
		contentMode: "Parcourir le contenu",
		nextComment: "Commentaire suivant",
		prevComment: "Commentaire précédent"
	},
	//
	listeners : {
		onCommentsDisplay  : [], //fired when "ON" button is clicked
		onCommentsHide : [], //fired when "OFF" button is clicked
		onThreadUpdate : [], //fired when a thred is updated (created, deleted, edited)
		onThreadBuilt : [], //fired when a thread is built		
		onAllThreadsBuilt : [] //fired when all the threads are built		
	},
 	params : {},	//Params object filled by the uiWidget in the template.		
	store : null	//LocalStorage used to memorise the state of the mgr.
};


scCommentMgr.update = function(pSync, pThreads, pPerms,pTimeStamp) {
	if (pSync) this.model.updateModel(pThreads);
	else this.model.setModel(pThreads);
	this.controller.updatePerms(pPerms);
	this.controller.loadThreads(this.model.fThreads);
	scCommentMgr.view.updateThreads();
}

scOnLoads.push(scCommentMgr);

scCommentMgr.onLoad = function(){
	try{
		if(navigator.userAgent.match("MSIE 7.0")){
			alert(scCommentMgr.strings.browserError);
		}
		else{
			scCommentMgr.store = new scCommentLib.LocalStore();
			var vPreviousCommentMode = scCommentMgr.store.get("scCommentMode");
			switch(scCommentMgr.params.postingMode){
				case "flow": scCommentMgr.view = new scCommentFlowWdg();break;
				case "margin" : scCommentMgr.view = new scCommentMarginWdg();break; //TODO ajouter code du widget en marge...
			}
			if(scCommentMgr.params.rootElementPath) scCommentMgr.rootNode = scPaLib.findNode(scCommentMgr.params.rootElementPath, document.body);
			else scCommentMgr.rootNode = scCommentMgr.params.rootElementNode || document.body;
			if(scCommentMgr.params.toolBarParentPath) scCommentMgr.toolBarNode = scPaLib.findNode(scCommentMgr.params.toolBarParentPath, document.body);
			else scCommentMgr.toolBarNode = scCommentMgr.params.toolBarParentNode || document.body;
			scCommentMgr.view.init();
			this.controller.toggleCommentMode(true);
			var vCommentsOff = false;
			switch(scCommentMgr.params.behavior){
				case "openedByDefault" : 
					if ( vPreviousCommentMode == "commentOff") vCommentsOff = true;
				break;
				case "closedByDefault" : 
					if ( vPreviousCommentMode != "commentOn") vCommentsOff = true;
				break;
				case "alwaysClosed" : 
					vCommentsOff = true;
				break;
			}
			if (vCommentsOff) scCommentMgr.controller.toggleCommentMode(true);
			else scCommentMgr.listeners.fire("onCommentsDisplay", scCommentMgr.rootNode);
		}
	} catch(e){
		scCoLib.log("SCOMMENT INIT ERROR: "+e);
	}
}





scCommentMgr.model.getRefUriIndex = function(pRefUri) {
	for (var i = 0; i < this.fThreads.length; i++) if (this.fThreads[i].refUri == pRefUri) return i;
	return null;
}

scCommentMgr.model.getThreadIndex = function(pIndex, pRelativePath) {
	for (var i = 0; i < this.fThreads[pIndex].threads.length; i++) if (this.fThreads[pIndex].threads[i].oriPath == pRelativePath) return i;
	return null;
}

scCommentMgr.model.getListRefUris = function() {
	var vReturn = new String();
	for (var i = 0; i < this.fThreads.length; i++) {
		vReturn += this.fThreads[i].refUri;
		if (i + 1 != this.fThreads.length) vReturn += "\t";
	}
	return vReturn;
}


scCommentMgr.model.getListTimeStamps = function() {
	var vReturn = new String();
	for (var i = 0; i < this.fThreads.length; i++) {
		vReturn += this.fThreads[i].syncTimeStamp;
		if (i + 1 != this.fThreads.length) vReturn += "\t";
	}
	return vReturn;
}


scCommentMgr.model.setModel = function(pModel) {
	this.fThreads = this.unescapeModel(pModel);
}


scCommentMgr.model.updateModel = function(pThreadChanges) {
	for (var i = 0; i < pThreadChanges.length; i++) {
		var vIndex = this.getRefUriIndex(pThreadChanges[i].refUri)

		if(pThreadChanges[i].syncTimeStamp) this.fThreads[vIndex].syncTimeStamp = pThreadChanges[i].syncTimeStamp;

		for (var j = 0 ; j < pThreadChanges[i].threads.length; j++) {
			var vThread = pThreadChanges[i].threads[j]
			switch (vThread.sync) {
			case '+' :
				vThread = this.unescapeThread(vThread);
				this.updateModelRelativePath(vThread.sync,pThreadChanges[i].refUri, vThread.oriPath);
				scCommentMgr.controller.updateControlOripaths(vThread.sync, pThreadChanges[i].refUri,vThread.oriPath);
				this.fThreads[vIndex].threads.push(vThread);
				var vIndex = scCommentMgr.view.fThreadList.getIndex(pThreadChanges[i].refUri,vThread.oriPath);
				if(vIndex!=null){
					scCommentMgr.view.fThreadList[vIndex].fThreadModel = vThread;
					scCommentMgr.view.fThreadList[vIndex].fThreadModel.status = "toRebuild";
				}
				break;

			case '~' :
				vThread = this.unescapeThread(vThread);
				var vCommentIndex = this.getThreadIndex(vIndex, vThread.oriPath);
				this.fThreads[vIndex].threads[vCommentIndex] = vThread;
				this.fThreads[vIndex].threads[vCommentIndex].status = "toRebuild";
				scCommentMgr.view.fThreadList[scCommentMgr.view.fThreadList.getIndex(this.fThreads[vIndex].refUri,this.fThreads[vIndex].threads[vCommentIndex].oriPath)].fThreadModel = vThread ;
				break;

			case '-' :
				var vCommentIndex = this.getThreadIndex(vIndex, vThread.oriPath);
				var vViewIndex = scCommentMgr.view.fThreadList.getIndex(pThreadChanges[i].refUri,vThread.oriPath);
				if(vViewIndex != null) scCommentMgr.view.fThreadList[vViewIndex].fThreadModel = null;
				this.fThreads[vIndex].threads.splice(vCommentIndex,1);
				this.updateModelRelativePath(vThread.sync,pThreadChanges[i].refUri, vThread.oriPath);
				scCommentMgr.controller.updateControlOripaths(vThread.sync, pThreadChanges[i].refUri,vThread.oriPath);
				break;
			}
		}
	}
}


scCommentMgr.model.removeCommentEditingForm = function() {
	for (var i = 0; i < this.fThreads.length; i++) for (var j = 0 ; j < this.fThreads[i].threads.length; j++){
		var vThread = this.fThreads[i].threads[j] ;
		for (var k = 0; k < vThread.comments.length; k++)
			if (vThread.comments[k].fEdit) {
				if (!vThread.comments[k].fDirectDelete){
					vThread.comments[k].fEdit = false;
					vThread.status = "toRebuild";
				}
				else{
					vThread.status = "toRebuild";
					vThread.comments.splice(k, 1)
				}
			}
	}
}


scCommentMgr.model.updateModelRelativePath = function(pCode, pRefUri,pRelativePath) {
	var vIndex = this.getRefUriIndex(pRefUri);
	var vRelativePath = pRelativePath.split("/");

	for (var i = 0 ; i < this.fThreads[vIndex].threads.length; i++) {
		var vModelOripath = this.fThreads[vIndex].threads[i].oriPath.split("/")

		if (vRelativePath.length <= vModelOripath.length) {
			for (var j = 0; j < vRelativePath.length; j++) {
				if (j + 1 != vRelativePath.length && vRelativePath[j] != vModelOripath[j]) break;
				else if (j + 1 == vRelativePath.length) {
					if (pCode == '+' && vModelOripath[j] >= vRelativePath[j]) 												vModelOripath[j]++;
					else if (pCode == '-' && scCommentMgr.controller.fFullDelete && vModelOripath[j] > vRelativePath[j]) 	vModelOripath[j]--;
				}
			}

			var vNewModelOripath = "";
			for (var k = 0; k < vModelOripath.length; k++) {
				if (k != 0) vNewModelOripath += "/";
				vNewModelOripath += vModelOripath[k];
			}

			if(vNewModelOripath != this.fThreads[vIndex].threads[i].oriPath){
				var vViewIndex = scCommentMgr.view.fThreadList.getIndex(this.fThreads[vIndex].refUri,this.fThreads[vIndex].threads[i].oriPath);
				if(vViewIndex!=null) scCommentMgr.view.fThreadList[vViewIndex].fThreadModel.status = "toRebuild";
				this.fThreads[vIndex].threads[i].oriPath = vNewModelOripath;
			}

		}

	}

}




scCommentMgr.model.unescapeModel = function(pModel) {
	for (var i = 0; i < pModel.length; i++) pModel[i].threads = this.unescapeThreads(pModel[i].threads);
	return pModel;
}
scCommentMgr.model.unescapeThreads = function(pThreads) {
	for (var i = 0; i < pThreads.length; i++) pThreads[i] = this.unescapeThread(pThreads[i]);
	return pThreads;
}
scCommentMgr.model.unescapeThread = function(pThread) {
	for (var i = 0; i < pThread.comments.length; i++) pThread.comments[i].content = scCommentLib.unescapeComment(pThread.comments[i].content);
	return pThread;
}





scCommentMgr.controller.toggleCommentMode = function(pNoEvent) {
	var vButton = scCommentMgr.view.getToggleButton();
	
	if(!this.fCommentMode){
		if(vButton){
			vButton.value = scCommentMgr.strings.turnOffLabel;
			vButton.title = scCommentMgr.strings.turnOffLabel;
			scCommentLib.changeHtmlClass(vButton, "turnOn", "turnOff");
		}
		scCommentLib.changeHtmlClass(scCommentMgr.rootNode, "scCommentOff", "scCommentOn");

		if (scCommentMgr.model.fThreads)  scCommentMgr.svc.sendRequest("List", scCommentMgr.model.getListRefUris(), scCommentMgr.model.getListTimeStamps());		
		else {
			var vRefUriList = this.getControlOriPathArray().getListRefUri();
			if(vRefUriList) scCommentMgr.svc.sendRequest("List", vRefUriList);
			else scCommentMgr.view.updateThreads();
		}
		scCommentMgr.store.set("scCommentMode", "commentOn");
		if (!pNoEvent) scCommentMgr.listeners.fire("onCommentsDisplay", scCommentMgr.rootNode);
	} else {
		if(vButton){
			vButton.value = scCommentMgr.strings.turnOnLabel;
			vButton.title = scCommentMgr.strings.turnOnLabel;
			scCommentLib.changeHtmlClass(vButton, "turnOff", "turnOn");
		}
		scCommentLib.changeHtmlClass(scCommentMgr.rootNode, "scCommentOn", "scCommentOff");
		scCommentMgr.store.set("scCommentMode", "commentOff");
		
		scCommentMgr.view.removeCommentControls();
		scCommentMgr.view.removeThreads();
		if (!pNoEvent) scCommentMgr.listeners.fire("onCommentsHide", scCommentMgr.rootNode);
	}
	this.fCommentMode = !this.fCommentMode;
	if("scSiLib" in window) scSiLib.fireResizedNode(scCommentMgr.rootNode);
}


scCommentMgr.controller.respondThread = function(pRefUri,pRelativePath, pCommentNumber) {

	if (this.fReverseRequest) {
		scCommentMgr.model.updateModel(this.fReverseRequest);
		this.loadThreads(scCommentMgr.model.fThreads);
	}
	scCommentMgr.model.removeCommentEditingForm();
	this.fReverseRequest = null;
	

	var vOldText = scCommentMgr.store.get("scCommentContent");
	var vFinalText;
	if(vOldText && vOldText != "none"){
		vFinalText = vOldText;
		scCommentMgr.store.set("scCommentContent", "none");
	}
	else vFinalText = scCommentMgr.strings.defaultCommentContent;
	

	var vComment = {
		user : scCommentMgr.svc.fUser,
		creationTime : new Date().getTime(),
		content : vFinalText,
		fEdit : true,
		fDirectDelete : true,
		fSelect : true
	};
	var i = scCommentMgr.model.getRefUriIndex(pRefUri);
	var j = scCommentMgr.model.getThreadIndex(i, pRelativePath);
	scCommentMgr.model.fThreads[i].threads[j].comments.push(vComment);
	scCommentMgr.model.fThreads[i].threads[j].status = "toRebuild";

	scCommentMgr.view.updateThreads();

	scCommentMgr.svc.prepareRequest("Respond", pRefUri+"#"+pRelativePath+"#"+pCommentNumber,	scCommentMgr.model.fThreads[i].syncTimeStamp);
}


scCommentMgr.controller.createThread = function(pIndexNodeAnc) {

	if(this.fReverseRequest) {
		scCommentMgr.model.updateModel(this.fReverseRequest);
		this.loadThreads(scCommentMgr.model.fThreads);
	}
	scCommentMgr.model.removeCommentEditingForm();
	

	var vOldText = scCommentMgr.store.get("scCommentContent");
	var vFinalText;
	if(vOldText && vOldText != "none"){
		vFinalText = vOldText;
		scCommentMgr.store.set("scCommentContent", "none");
	}
	else vFinalText = scCommentMgr.strings.defaultCommentContent;
	

	var vRequest = [{
		refUri : this.fControlOriPathArray[pIndexNodeAnc].fRefUri,
		threads : [{
			sync : "+",
			oriPath : this.fControlOriPathArray[pIndexNodeAnc].fRelativePath+"/1",
			excludedThread : false,
			threadClosed : false,
			comments : [{
						user : scCommentMgr.svc.fUser,
						creationTime : new Date().getTime(),
						content : vFinalText,
						fEdit : true,
						fSelect : true
					}]
		}]
	}];
	
	scCommentMgr.model.updateModel(vRequest);
	this.loadThreads(scCommentMgr.model.fThreads);
	scCommentMgr.view.updateThreads();
	

	vRequest[0].threads[0].sync = "-";
	this.fFullDelete = true;
	this.fReverseRequest = vRequest;
	
	
	var vOripath = this.fControlOriPathArray[pIndexNodeAnc].toString();
	var vTimeStamp;
	for (var i = 0; i < scCommentMgr.model.fThreads.length; i++) 
		if (scCommentMgr.model.fThreads[i].refUri == this.fControlOriPathArray[pIndexNodeAnc].fRefUri) 
			vTimeStamp = scCommentMgr.model.fThreads[i].syncTimeStamp;
	

	scCommentMgr.svc.prepareRequest("Create",vOripath, vTimeStamp);
}


scCommentMgr.controller.updateComment = function(pRefUri, pRelativePath, pCommentNumber) {

	if (this.fReverseRequest) {
		scCommentMgr.model.updateModel(this.fReverseRequest);
		this.loadThreads(scCommentMgr.model.fThreads);
	}
	scCommentMgr.model.removeCommentEditingForm();
	this.fReverseRequest = null;

	var i = scCommentMgr.model.getRefUriIndex(pRefUri);
	var j = scCommentMgr.model.getThreadIndex(i, pRelativePath);

	scCommentMgr.model.fThreads[i].threads[j].comments[pCommentNumber].fEdit = true;
	scCommentMgr.model.fThreads[i].threads[j].status = "toRebuild";
	scCommentMgr.view.updateThreads();

	scCommentMgr.svc.prepareRequest("Update",pRefUri+"#"+pRelativePath+"#"+pCommentNumber,scCommentMgr.model.fThreads[i].syncTimeStamp);
}


scCommentMgr.controller.closeThread = function(pRefUri, pRelativePath) {

	if (this.fReverseRequest) {
		scCommentMgr.model.updateModel(this.fReverseRequest);
		this.loadThreads(scCommentMgr.model.fThreads);
	}
	scCommentMgr.model.removeCommentEditingForm();
	this.fReverseRequest = null;
	var i = scCommentMgr.model.getRefUriIndex(pRefUri);

	scCommentMgr.svc.sendRequest("Close",pRefUri+"#"+pRelativePath, scCommentMgr.model.fThreads[i].syncTimeStamp);
}


scCommentMgr.controller.deleteComment = function(pRefUri, pRelativePath, pCommentNumber) {

	if (this.fReverseRequest) {
		scCommentMgr.model.updateModel(this.fReverseRequest);
		this.loadThreads(scCommentMgr.model.fThreads);
	}
	scCommentMgr.model.removeCommentEditingForm();
	this.fReverseRequest = null;
	

	var i = scCommentMgr.model.getRefUriIndex(pRefUri);
	var j = scCommentMgr.model.getThreadIndex(i, pRelativePath);
	this.fFullDelete = scCommentMgr.model.fThreads[i].threads[j].comments.length == 1 ? true : false;
	

	if (window.confirm(scCommentMgr.strings.deletingWarning)){
		var vOripath = pCommentNumber!=null? pRefUri+"#"+pRelativePath+"#"+pCommentNumber : pRefUri+"#"+pRelativePath;
		scCommentMgr.svc.sendRequest("Delete", vOripath,scCommentMgr.model.fThreads[i].syncTimeStamp);
	}
}






scCommentMgr.controller.editingFormSubmit = function(pText) {
	if (this.fReverseRequest) scCommentMgr.model.updateModel(this.fReverseRequest);
	this.fReverseRequest = null;
	scCommentMgr.svc.setText(pText);
	scCommentMgr.svc.sendRequest();
}


scCommentMgr.controller.editingFormCancel = function() {
	if (scCommentMgr.controller.fReverseRequest){
		scCommentMgr.model.updateModel(scCommentMgr.controller.fReverseRequest);
		scCommentMgr.controller.loadThreads(scCommentMgr.model.fThreads);
	}
	scCommentMgr.controller.fReverseRequest = null;
	scCommentMgr.model.removeCommentEditingForm();
	scCommentMgr.view.updateThreads();
}


scCommentMgr.controller.getControlOriPathArray = function() {
	if (!this.fControlOriPathArray) this.fControlOriPathArray = this.recursiveOripathSearch(scCommentMgr.rootNode, new scCommentLib.OriPathArray(), null);
	return this.fControlOriPathArray;
}


scCommentMgr.controller.loadThreads = function(pCommentThreads) {
	if(!scCommentMgr.view.fThreadList) scCommentMgr.view.fThreadList =  new scCommentLib.ThreadArray();

	for (var i = 0; i < pCommentThreads.length; i++) for (var j = 0 ; j < pCommentThreads[i].threads.length; j++){
		var vThreadModel = pCommentThreads[i].threads[j];

		if (scCommentMgr.view.fThreadList.getIndex(pCommentThreads[i].refUri,vThreadModel.oriPath) == null) {
			var vOriPathAnchor = this.proximityResolver(pCommentThreads[i].refUri,vThreadModel.oriPath);
			if (vOriPathAnchor) scCommentMgr.view.fThreadList.addEntry(vOriPathAnchor, vThreadModel, pCommentThreads[i].refUri);
		}
	}
}


scCommentMgr.controller.updateControlOripaths = function(pRequest, pRefUri, pRelavitePath) {
	var vPath = pRelavitePath.split("/");
	var vIndex = vPath.length - 1;

	for (var i = 0 ; i < this.fControlOriPathArray.length; i++) {
		var vNodePath = this.fControlOriPathArray[i].fRelativePath.split("/")
		if (pRefUri == this.fControlOriPathArray[i].fRefUri && vPath.length <= vNodePath.length) {
			for (var j = 0; j < vPath.length; j++) {
				if (j + 1 != vPath.length && vPath[j] != vNodePath[j]) break;
				else if (j + 1 == vPath.length) {
					if (pRequest == '+' && vNodePath[vIndex] >= vPath[vIndex]) vNodePath[vIndex]++;
					if (pRequest == '-' && this.fFullDelete && vNodePath[vIndex] > vPath[vIndex]) vNodePath[vIndex]--;
				}
			}
			var vReturnPath = "";
			for (var j = 0; j < vNodePath.length; j++) {
				if (j != 0) vReturnPath += "/";
				vReturnPath += vNodePath[j];
			}
			this.fControlOriPathArray[i].fRelativePath = vReturnPath;
		}
	}

}


scCommentMgr.controller.proximityResolver = function(pRefUri, pRelativePath) {
	this.getControlOriPathArray();
	var vOripath = null;
	var vSize = 0;

	for (var i = 0; i < this.fControlOriPathArray.length; i++) {
		if (this.fControlOriPathArray[i].fRefUri == pRefUri) {
			var vMode = this.fControlOriPathArray[i].fMode;

			var vDepth = parseInt(vMode);
			if(vDepth){
				vMode = "node";
			}
			else if(vMode.match("node.?.?")) {

				var vDepth = parseInt(vMode.substr(4)) ? parseInt(vMode.substr(4)): 1;
				vMode = "node";
			}
			switch (vMode) {
				case "node" :


					



					if(pRelativePath.match("^"+this.fControlOriPathArray[i].fRelativePath+".+$") && (pRelativePath.length - this.fControlOriPathArray[i].fRelativePath.length) / 2 <= vDepth*2){

						if (this.fControlOriPathArray[i].fRelativePath.length > vSize) {
							vOripath = this.fControlOriPathArray[i];
							vSize = this.fControlOriPathArray[i].fRelativePath.length
						}
					}
					break;
				case "leaf" :
					if (pRelativePath.match("^"+this.fControlOriPathArray[i].fRelativePath+".+$")) {

						if (this.fControlOriPathArray[i].fRelativePath.length > vSize){
							vOripath = this.fControlOriPathArray[i];
							vSize = this.fControlOriPathArray[i].fRelativePath.length;
						}
					}
					break;
				default :
					throw "unknown proximity resolver mode";
					break;
			}
		}
	}
	return vOripath;
}


scCommentMgr.controller.recursiveOripathSearch = function(pNode, pOriPathArray, pString) {
	if (pNode.attributes) {
		var vDataOrigin = pNode.attributes.getNamedItem('data-origin');
		if (vDataOrigin) {
			vDataOrigin = vDataOrigin.value;
			if (vDataOrigin.charAt(0) == '@') pString = vDataOrigin.substring(1, vDataOrigin.indexOf('?'))+"#"+ vDataOrigin.substring(vDataOrigin.indexOf('#')+ 1,vDataOrigin.length);
			else if (vDataOrigin.charAt(0) == '#') pString = pString.split("#")[0]+"#"+ vDataOrigin.substring(1);
			else pString+="/"+vDataOrigin;
			if (!scCommentLib.getParam(scCommentMgr.params.excludeNode, pNode)) pOriPathArray.pushOripath(pString, pNode);
		}
	}
	var vChildren = pNode.children;
	if(vChildren) for (var i = 0; i < vChildren.length; i++) pOriPathArray = this.recursiveOripathSearch(vChildren[i], pOriPathArray, pString);
	return pOriPathArray;
}


scCommentMgr.controller.updatePerms = function(pPerms) {
	var isModified = false;

	if(!this.fPerms){
		this.fPerms = pPerms;
		isModified = true;
	}

	else
		for (var i = 0; i < pPerms.length; i++) for (var j = 0; j < this.fPerms.length; j++) 
			if(pPerms[i].refUri == this.fPerms[j].refUri && pPerms[i].perms != this.fPerms[j].perms){
				this.fPerms[j].perms = pPerms[i].perms;
				isModified = true;
			}


	if (isModified)
		for (var i = 0; i < this.fControlOriPathArray.length; i++) for (var j = 0; j < this.fPerms.length; j++)
			if (this.fPerms[j].refUri == this.fControlOriPathArray[i].fRefUri){
				var vUpdateControls = this.fControlOriPathArray[i].fPerms==null?true:this.fControlOriPathArray[i].fPerms.Create != this.fPerms[j].perms.Create;
				this.fControlOriPathArray[i].fPerms = this.fPerms[j].perms;

				if(vUpdateControls) scCommentMgr.view.updateCommentControl(this.fControlOriPathArray[i], i);
			}	
}



scCommentMgr.svc.prepareRequest = function(pRequest, pOriPathStr, pTimeStamps, pXPath, pXPathNS, pText) {		
	if (pRequest) 	this.fRequest = encodeURIComponent(pRequest);
	if (pOriPathStr)this.fOriPathStr = encodeURIComponent(pOriPathStr);
	if (pText) 		this.fUnencodedText = pText;
	if (pXPath) 	this.fXPath = pXPath;
	if (pXPathNS) 	this.fXPathNS = pXPathNS;
	if (pTimeStamps)this.fTimeStamps = encodeURIComponent(pTimeStamps);
}


scCommentMgr.svc.setText = function(pText) {this.fUnencodedText = pText;},


scCommentMgr.svc.sendRequest = function(pRequest, pOriPathStr, pTimeStamps, pXPath, pXPathNS, pText) {
	this.prepareRequest(pRequest, pOriPathStr, pTimeStamps, pXPath, pXPathNS, pText);		
	this.fText = encodeURIComponent(scCommentLib.escapeComment(this.fUnencodedText));
	
	var vExp = /(.*\/u\/)itemDynGen\/(.+?)\/.*/;
	var vTable = vExp.exec(location.pathname);
	var vURL = vTable[1] + "comment?param=" + vTable[2] + '&cdaction=' + this.fRequest;
	switch (this.fRequest) {
		case 'List' :
			vURL +='&RefUris='+this.fOriPathStr+'&ExcludeXPathNS='+this.fXPathNS+'&ExcludeXPath='+this.fXPath;
			if(this.fTimeStamps) vURL += '&TimeStamps='+this.fTimeStamps;
			break;
		case 'Create' :
		case 'Update' :
		case 'Respond':
			vURL +='&OriPath='+this.fOriPathStr+'&Text='+this.fText+'&TimeStamps='+this.fTimeStamps+'&ExcludeXPathNS='+this.fXPathNS +'&ExcludeXPath='+ this.fXPath;
			break;
		case 'Delete':
		case 'Close' :
			vURL +='&OriPath='+this.fOriPathStr+'&TimeStamps='+ this.fTimeStamps;
			break;
	}
	
	var vXhr= new XMLHttpRequest();
	vXhr.open("GET", vURL);
	vXhr.onreadystatechange = function(){
		if(vXhr.readyState != 4) return;
		var vError = false;
			try{
				var vAnswer = JSON.parse(vXhr.responseText);
				scCommentMgr.svc.fUser = vAnswer.user;
				scCommentMgr.update(vAnswer.synchronizedResponse, vAnswer.threadArray, vAnswer.permArray, vAnswer.requestTimeStamp);
				if(!vAnswer.synchronizedResponse && scCommentMgr.svc.fInit) throw {error:"synchro", message:scCommentMgr.strings.synchronizationError};
				if(!vAnswer.hasPermission) throw {error:"perm", message:scCommentMgr.strings.permissionError};
				if(!scCommentMgr.svc.fInit) scCommentMgr.svc.fInit = true ;
			}
			catch(e){
				switch(e.error){
					case "synchro" :
						var vText = e.message+" "+scCommentMgr.strings.editedInScError+"\n";
						if (scCommentMgr.svc.fRequest == "Update" || scCommentMgr.svc.fRequest == "Create"){
							vText += scCommentMgr.strings.commentStoredMessage+" ";	
							scCommentMgr.store.set("scCommentContent", scCommentMgr.svc.fUnencodedText);
						}
						vText += scCommentMgr.strings.tryAgainMessage;
					break;
					
					case "perm" :
						var vText = e.message+"\n";
						if (scCommentMgr.svc.fRequest == "Update" || scCommentMgr.svc.fRequest == "Create"){
							scCommentMgr.svc += scCommentMgr.strings.commentStoredMessage+" ";	
							scCommentMgr.store.set("scCommentContent", scCommentMgr.svc.fUnencodedText);
						}
						vText += scCommentMgr.strings.contactAdminMessage;
					break;	
					
					default:
						var vText = scCommentMgr.strings.serverError +" ";
						if (scCommentMgr.svc.fRequest == "Update" || scCommentMgr.svc.fRequest == "Create"){
							vText += scCommentMgr.strings.commentStoredMessage+" ";	
							scCommentMgr.store.set("scCommentContent", scCommentMgr.svc.fUnencodedText);
						}
						vText += scCommentMgr.strings.reloadMessage;
					break;
				}
				if(scCoLib.fDebug){
					vText+="\n\n ************ DEBUG ************ "
					+ "\n" + e
					+ "\n\n" + vXhr.responseText
					+ "\n\n*******************************";
				}
				alert(vText);
			}
	};			
	vXhr.send();
}


scCommentMgr.listeners.register = function(pType, pFunc){
	this[pType].push(pFunc);
}

scCommentMgr.listeners.fire = function(pType, pNode){
	
	for(var i=0; i<this[pType].length; i++) {
		try {
			this[pType][i](pNode);
		} catch(e) {scCoLib.log("ERROR scCommentMgr.listeners.fire - "+pType+" : ",e);}
	}
}



scCommentLib = {
	/**
	 * build date as string from object Date
	 * @param {Date} pTimeMilliSec
	 * @return {string}
	 */
	writeDate : function(pTimeMilliSec) {
		var vDate = new Date(pTimeMilliSec);
		var vDay = new String(vDate.getDate());
		if (vDay.length == 1) vDay = "0" + vDay;

		var vMonth = new String(vDate.getMonth() + 1);
		if (vMonth.length == 1) vMonth = "0" + vMonth;

		var vHour = new String(vDate.getHours());
		if (vHour.length == 1) vHour = "0" + vHour;
		var vMinutes = new String(vDate.getMinutes());
		if (vMinutes.length == 1)vMinutes = "0" + vMinutes;
		
		return vDay+"/"+vMonth+"/"+vDate.getFullYear()+" "+vHour+":"+vMinutes;
	},
	/**
	 * Add a class to an HTML node
	 * @param {DOMElement} pNode
	 * @param {string} pClass the class to add
	 */
	addHtmlClass : function(pNode, pClass) {
		if(pNode.className){
			var vTab = pNode.className.split(" ");
			for (var i = 0; i < vTab.length; i++) if (vTab[i] == pClass) return
			if (vTab.length != 0) pNode.className += " ";
			pNode.className += pClass;
		}
		else pNode.className = pClass;
	},
	/**
	 * Remove a class from an HTML class
	 * @param {DOMElement} pNode
	 * @param {string} pClass
	 */
	removeHtmlClass : function(pNode, pClass) {
		if(!pNode.className) return;
		var vTab = pNode.className.split(" ");
		var vClass = "";
		for (var i = 0; i < vTab.length; i++) if (vTab[i] != pClass && vTab[i] != "") vClass += " " + vTab[i];
		pNode.className = vClass;
	},
	/**
	 * change a class from an HTML node
	 * @param {DOMElement} pNode
	 * @param {string} pOldClass the class to remove
	 * @param {string} pNewClass the class to add
	 */
	changeHtmlClass : function(pNode, pOldClass, pNewClass) {
		this.removeHtmlClass(pNode, pOldClass);
		this.addHtmlClass(pNode, pNewClass);
	},

	/**
	 * check if a HTML Node contains a class
	 * @param {DOMElement} pNode
	 * @param {string} pClass the class to check
	 * @return {Boolean}
	 */
	containsHtmlClass : function(pNode, pClass) {
		if(pNode.className){
			var vTab = pNode.className.split(" ");
			for (var i = 0; i < vTab.length; i++) if (vTab[i] == pClass) return true;
		}
		return false;
	},
	
	/** Protect characters -- by -~- */
	escapeComment : function(pText) {
		if (!pText) return pText;
		return pText.replace(/(-\~*)(?=-)/g, "$1~"); 
	},
	/** Transform back -- */
	unescapeComment : function(pText) {
		if (!pText) return pText;
		return pText.replace(/(-\~*)\~(?=-)/g, "$1");
	},
	/**
	 * get a scCommentParam (insertFirst, overloadRule, etc.)
	 * @param {Array} pParams the array param (published in the frame)
	 * @param {HTMLElement} The node being tested.
	 * @return {Boolean}
	 */
	getParam : function(pParams, pNode){
		if(!pParams || !pParams.length) return false;
		for (var i = 0; i < pParams.length; i++) {
			switch (pParams[i][0]) {
				case "cn" :  
					if (scPaLib.checkNode(pParams[i][1], pNode)) return pParams[i][2] || true;
					break;
				case "fn" :
					if(scPaLib.findNode(pParams[i][1], scCommentMgr.rootNode) == pNode) return pParams[i][2] || true;
						break;
				case "fns" :
					var vNodes = scPaLib.findNodes(pParams[i][1], scCommentMgr.rootNode);
					for (var j = 0; j < vNodes.length; j++) if (vNodes[j] == pNode) return pParams[i][2] || true;
					break;
			}
		}
		return false;
	},
	/**
	 * Build a string by replacing variable by params.
	 * @param {String} pStr A string containing variables (%s1, %s2, etc.)
	 * @param {String} pParam1
	 * @param {String} pParam2
	 * @param {String} pParam3
	 * @param {String} pParam4
	 * @return {String}
	 */
	buildString : function(pStr, pParam1, pParam2, pParam3, pParam4){
		if(pParam1) pStr = pStr.replace("%s1", pParam1);
		if(pParam2) pStr = pStr.replace("%s2", pParam2);
		if(pParam3) pStr = pStr.replace("%s3", pParam3);
		if(pParam4) pStr = pStr.replace("%s4", pParam4);
		return pStr;
	},
	/**
	 * Wrap scDynUiMgr and build a button.
	 * @param {HTMLElement} pParent parent of the button
	 * @param {String} pClass optional
	 * @param {HTMLElement} pFollower optional
	 * @param {String} pTitle optional
	 * @param {Function} pOnClick optional
	 * @return {HTMLButton}
	 */
	addButton : function(pParent, pClass, pFollower, pTitle, pOnClick){
		var vButton = scDynUiMgr.addElement("button", pParent, pClass, pFollower);
		vButton.setAttribute("type","button");
		vButton.setAttribute("title", pTitle);
		vButton.setAttribute("value", pTitle);
		if(pOnClick) vButton.onclick = pOnClick;
		return vButton;
	},
	
	addEventListener: function(pElement, pType, pListener) {
		if (pElement.addEventListener) pElement.addEventListener(pType, pListener, false);
		else if (pElement.attachEvent) {
			if (!pElement._scListeners) pElement._scListeners = new Array();
			if (!pElement._scListeners[pType]) pElement._scListeners[pType] = new Array();
			var vListener = function(pEvent) {
				pEvent = window.event;
				pEvent.target = pEvent.srcElement;
				pListener.call(pElement, pEvent);
			}
			pElement._scListeners[pType][pListener] = vListener;
			pElement.attachEvent('on' + pType, vListener);
		}
	},

	removeEventListener: function(pElement, pType, pListener) {
		if (pElement.removeEventListener) pElement.removeEventListener(pType, pListener, false);
		else if (pElement.detachEvent) {
			if (pElement._scListeners && pElement._scListeners[pType] && pElement._scListeners[pType][pListener]) {
				pElement.detachEvent('on' + pType, pElement._scListeners[pType][pListener]);
			}
		}
	},
	
	stopPropagation: function(pEvent) {
		if (pEvent.stopPropagation) pEvent.stopPropagation();
		else pEvent.cancelBubble = true;
	},
	
	compareDocumentPosition: function (pEl1, pEl2) {
		if (pEl1.compareDocumentPosition) return pEl1.compareDocumentPosition(pEl2);
		else {
			/*
	        Node.DOCUMENT_POSITION_DISCONNECTED = 1;
	        Node.DOCUMENT_POSITION_PRECEDING = 2
	        Node.DOCUMENT_POSITION_FOLLOWING = 4;
	        Node.DOCUMENT_POSITION_CONTAINS = 8;
	        Node.DOCUMENT_POSITION_CONTAINED_BY = 16;
	        Node.DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC = 32;
			*/
			return (pEl1 != pEl2 && pEl1.contains(pEl2) && 16) +
				(pEl1 != pEl2 && pEl2.contains(pEl1) && 8) +
				(pEl1.sourceIndex >= 0 && pEl2.sourceIndex >= 0 ?
					(pEl1.sourceIndex < pEl2.sourceIndex && 4) +
					(pEl1.sourceIndex > pEl2.sourceIndex && 2) 
					: 1
				) + 0;
		}
	},
	

	getOffsetLeft: function(pNode, pContainer) {
		var vParent = pNode.offsetParent;
		if( ! vParent) return pNode.offsetLeft;
		var vOffset = pNode.offsetLeft - vParent.scrollLeft;
		while(vParent != pContainer) {
			var vNewParent = vParent.offsetParent;
			if( ! vNewParent) return Number.NaN;
			vOffset += vParent.offsetLeft - vNewParent.scrollLeft;
			vParent = vNewParent;
		}
		return vOffset;
	}

}







scCommentLib.Thread = function(pAnchorOripath, pThreadModel, pRefUri, pNode) {
	this.fNode = pNode; 					// html Node
	this.fAnchorOripath = pAnchorOripath;	// oripathObject
	this.fThreadModel = pThreadModel;		// thread model from scenari serveur
	this.fRefUri = pRefUri;					// refuri of the thread model
}


scCommentLib.Thread.prototype.bt = function(pThread){
	if(this.fAnchorOripath.st(pThread.fAnchorOripath)) return true;
	else if(this.fThreadModel && pThread.fThreadModel) return this.fThreadModel.oripath < pThread.fThreadModel.oriPath;
	else return true;
}
 




scCommentLib.ThreadArray = function() {}
scCommentLib.ThreadArray.prototype = new Array;



scCommentLib.ThreadArray.prototype.getIndex = function(pRefUri, pOripath) {
	for (var i = 0; i < this.length; i++) if (this[i].fThreadModel && this[i].fRefUri == pRefUri && this[i].fThreadModel.oriPath == pOripath) return i;
	return null;
}


scCommentLib.ThreadArray.prototype.addEntry = function(pAnchorOripath, pThreadModel, pRefUri ,pNode) {
	var vThread = new scCommentLib.Thread(pAnchorOripath, pThreadModel, pRefUri ,pNode);
	var i = 0;
	while(i < this.length && this[i].bt(vThread)) i++;
	this.splice(i, 0, vThread);
	return i;
}







scCommentLib.OriPath = function(pOripath, pNode, pMode) {
	var vOripathTab = pOripath.split('#');
	this.fRelativePath = vOripathTab[1]; 	//relative Path
	this.fRefUri = vOripathTab[0]; 		 	//refUri
	this.fNode = pNode;					 	//HTML element containing the oripath
	this.fCommentContainerNode = null;		//HTML element containing the threads linked to this 
	this.fMode = pMode ? pMode : "leaf";	//association mode between a oripath and a thread (leaf, node, node2, etc.)
	this.fPerms = null;						//perms of the current logged user on this oripath
}

scCommentLib.OriPath.prototype.toString = function(pCommentNumber) {
	if (pCommentNumber) return this.fRefUri + "#" + this.fRelativePath + "#" + pCommentNumber;
	else return this.fRefUri + "#" + this.fRelativePath;
}


scCommentLib.OriPath.prototype.st = function(pOripath){
	var vPosition = scCommentLib.compareDocumentPosition(pOripath.fNode, this.fNode);
	return vPosition & 2 /* DOCUMENT_POSITION_PRECEDING */;
}






scCommentLib.OriPathArray = function() {}
scCommentLib.OriPathArray.prototype = new Array;


scCommentLib.OriPathArray.prototype.getOripathObject = function(pOripath) {
	for (var i = 0; i < this.length; i++) 
		if (this[i].toString() === pOripath || this[i].fCommentContainerNode === pOripath) return this[i];
	return null;
}


scCommentLib.OriPathArray.prototype.getListRefUri = function() {
	var vRefUris = "";
	var vWrittenRefUri = new Array();
	var vAdd;
	for (var i = 0; i < this.length; i++) {
		vAdd = true;
		for (var j = 0; j < vWrittenRefUri.length; j++)
			if (this[i].fRefUri == vWrittenRefUri[j]) vAdd = false;
		if (vAdd) {
			if (vRefUris) vRefUris += "\t";
			vRefUris += this[i].fRefUri;
			vWrittenRefUri.push(this[i].fRefUri);
		}
	}
	return vRefUris;
}


scCommentLib.OriPathArray.prototype.pushOripath = function(pOripath, pNode) {
	this.push(new scCommentLib.OriPath(pOripath, pNode, scCommentLib.getParam(scCommentMgr.params.overloadAssociationRules, pNode)));
}


scCommentLib.LocalStore = function(pId) {
	if (pId && !/^[a-z][a-z0-9]+$/.exec(pId)) throw new Error("Invalid store name");
	this.fId = pId || "";
	this.fRootKey = document.location.pathname.substring(0,document.location.pathname.lastIndexOf("/"))+ "/";
	if ("localStorage" in window && typeof window.localStorage != "undefined") {
		this.get = function(pKey) {
			var vRet = localStorage.getItem(this.fRootKey + this.xKey(pKey));
			return (typeof vRet == "string" ? unescape(vRet) : null)
		};
		this.set = function(pKey, pVal) { localStorage.setItem(this.fRootKey + this.xKey(pKey), escape(pVal)) };
	} else if (window.ActiveXObject) {
		this.get = function(pKey) { this.xLoad(); return this.fIE.getAttribute(this.xEsc(pKey)) };
		this.set = function(pKey, pVal) {this.fIE.setAttribute(this.xEsc(pKey), pVal); this.xSave() };
		this.xLoad = function() { this.fIE.load(this.fRootKey + this.fId)};
		this.xSave = function() { this.fIE.save(this.fRootKey + this.fId) };
		this.fIE = document.createElement('div');
		this.fIE.style.display = 'none';
		this.fIE.addBehavior('#default#userData');
		document.body.appendChild(this.fIE);
	} else {
		this.get = function(pKey) {
			var vReg = new RegExp(this.xKey(pKey) + "=([^;]*)");
			var vArr = vReg.exec(document.cookie);
			if (vArr && vArr.length == 2) return (unescape(vArr[1]));
			else return null
		};
		this.set = function(pKey, pVal) { document.cookie = this.xKey(pKey) + "=" + escape(pVal) };
	}
	this.xKey = function(pKey) { return this.fId + this.xEsc(pKey) };
	this.xEsc = function(pStr) { return "LS" + pStr.replace(/ /g, "_") };
}




scCommentViewWdg = function() {
	this.fThreadList = new scCommentLib.ThreadArray();			 //ordored array of ThreadModel @type scCommentLib.ThreadModelArray
	if (window.addEventListener) window.addEventListener("beforeunload", scCommentViewWdg.prototype.exitWindow);
	else  window.attachEvent("onbeforeunload", scCommentViewWdg.prototype.exitWindow);
}


scCommentViewWdg.prototype.buildThread = function(pThread) {

	scCommentLib.addHtmlClass(pThread.fAnchorOripath.fNode, "scCommented");
	if (pThread.fThreadModel.comments.length > 1) scCommentLib.addHtmlClass(pThread.fAnchorOripath.fNode, "scCommentMulti");
	if (pThread.fThreadModel.threadClosed) scCommentLib.addHtmlClass(pThread.fNode, "closed");
	else scCommentLib.addHtmlClass(pThread.fNode, "open");
	

	if (scCoLib.fDebug) {
		var vThreadOriPathContainer = scDynUiMgr.addElement("div", pThread.fNode, "debugPath");
		if (pThread.fThreadModel.threadClosed) vThreadOriPathContainer.className = "debugPathFloat";
		vThreadOriPathContainer.appendChild(document.createTextNode("Oripath : "+ pThread.fRefUri+"#"+pThread.fThreadModel.oriPath));
	}
	

	var vEdit = false;
	for (var k = 0; k < pThread.fThreadModel.comments.length; k++) if(pThread.fThreadModel.comments[k].fEdit){ vEdit = true ; break;}
	if(!vEdit){
		var vThreadTools = scDynUiMgr.addElement("div",pThread.fNode, "threadTools");	
		if(pThread.fAnchorOripath.fPerms.Delete){
			var vDeleteThreadButton = scCommentLib.addButton(vThreadTools, "deleteThread", null, scCommentMgr.strings.deleteLabel);
			vDeleteThreadButton.setAttribute("onclick","scCommentMgr.view.formClosing(\""+pThread.fRefUri+"\",\""+pThread.fThreadModel.oriPath+"\",null,\"delete\")");
		}
		
		if(pThread.fAnchorOripath.fPerms.Close){
			var vValidButton = scCommentLib.addButton(vThreadTools);
			vValidButton.setAttribute("onclick","scCommentMgr.view.formClosing(\""+pThread.fRefUri+"\",\""+pThread.fThreadModel.oriPath+"\",null,\"valid\")");
			if(pThread.fThreadModel.threadClosed){
				vValidButton.className ="open";
				vValidButton.value = scCommentMgr.strings.openThreadLabel;
				vValidButton.title = scCommentMgr.strings.openThreadLabel;
			}
			else{
				vValidButton.className = "close";
				vValidButton.value = scCommentMgr.strings.closeThreadLabel;
				vValidButton.title = scCommentMgr.strings.closeThreadLabel;
			}
		}
	}
	

	for (var k = 0; k < pThread.fThreadModel.comments.length; k++) {

		var vDivComment = scDynUiMgr.addElement("div",pThread.fNode, "comment");
		var vDivCommentInside = scDynUiMgr.addElement("div",vDivComment, "commentInside");
		if (!k) scCommentLib.addHtmlClass(vDivComment, "first");
		if (k%2) scCommentLib.addHtmlClass(vDivComment, "even");
		else scCommentLib.addHtmlClass(vDivComment, "odd");
		if (k + 1 == pThread.fThreadModel.comments.length) scCommentLib.addHtmlClass(vDivComment, "last");
		

		if(!pThread.fThreadModel.comments[k].fEdit && !pThread.fThreadModel.threadClosed){
			var vdivTools = scDynUiMgr.addElement("div",vDivCommentInside, "tools");
			if(pThread.fAnchorOripath.fPerms.Update || pThread.fThreadModel.comments[k].user == "" ||
			    pThread.fAnchorOripath.fPerms.Update_AsCurrentUser && pThread.fThreadModel.comments[k].user == scCommentMgr.svc.fUser ){
				
				var vButtonUpdate = scCommentLib.addButton(vdivTools, "editButton", null, scCommentMgr.strings.editCommentLabel);
				vButtonUpdate.setAttribute("onclick","scCommentMgr.view.formClosing(\""+pThread.fRefUri+"\",\""+pThread.fThreadModel.oriPath+"\","+k+",\"update\")");
			}
			if(pThread.fAnchorOripath.fPerms.Delete || pThread.fThreadModel.comments[k].user == "" || 
			    pThread.fAnchorOripath.fPerms.Delete_AsCurrentUser && pThread.fThreadModel.comments[k].user == scCommentMgr.svc.fUser){
				var vButtonDelete = scCommentLib.addButton(vdivTools, "deleteButton", null, scCommentMgr.strings.deleteLabel);
				vButtonDelete.setAttribute("onclick","scCommentMgr.view.formClosing(\""+pThread.fRefUri+"\",\""+pThread.fThreadModel.oriPath+"\","+ k +",\"delete\")");
			}
		}

		var vMetaDiv = scDynUiMgr.addElement("div",vDivCommentInside, "meta");
		if (pThread.fThreadModel.comments[k].user != "") vMetaDiv.appendChild(document.createTextNode(pThread.fThreadModel.comments[k].user + " - "));
		vMetaDiv.appendChild(document.createTextNode(scCommentLib.writeDate(parseInt(pThread.fThreadModel.comments[k].creationTime))));


		var vContentDiv = scDynUiMgr.addElement("div",vDivCommentInside, "content");

		if (pThread.fThreadModel.comments[k].fEdit) {
			scCommentLib.addHtmlClass(vDivComment, "edit");
			var vEditForm = scDynUiMgr.addElement("div",vDivCommentInside, "editForm");
			
			var vOnClick = function(event){
				var vEvent = event || window.event;
				var vElement = vEvent.srcElement || vEvent.toElement || vEvent.target;
				scCommentMgr.controller.editingFormSubmit(scPaLib.findNode("nsi:textarea",vElement).value);
			};
			
			scCommentLib.addButton(vEditForm, "validButton", null,scCommentMgr.strings.saveLabel, vOnClick)
			var vEditFormCancel = scCommentLib.addButton(vEditForm, "cancelEditButton", null, scCommentMgr.strings.cancelLabel, scCommentMgr.controller.editingFormCancel)
			if (pThread.fThreadModel.comments[k].fSelect) vEditFormCancel.className = "cancelCreateButton";

			var vTextArea =  scDynUiMgr.addElement("textarea",vEditForm, "editformArea");
			vTextArea.appendChild(document.createTextNode(pThread.fThreadModel.comments[k].content));
			vTextArea.focus();
			if (pThread.fThreadModel.comments[k].fSelect) vTextArea.select();
		}

		else {
			var vCommentContent = scDynUiMgr.addElement("p",vContentDiv);
			vCommentContent.appendChild(document.createTextNode(pThread.fThreadModel.comments[k].content));
		}
		

		if (k + 1 == pThread.fThreadModel.comments.length) {
			var vBottomDiv = scDynUiMgr.addElement("div",pThread.fNode, "bottom");


			if(!vEdit && pThread.fAnchorOripath.fPerms.Respond && !pThread.fThreadModel.threadClosed){
				var vButtonRespond = scCommentLib.addButton(vBottomDiv, "addButton", null, scCommentMgr.strings.answerLabel);
				vButtonRespond.setAttribute("onclick","scCommentMgr.view.formClosing(\""+pThread.fRefUri+"\",\""+pThread.fThreadModel.oriPath+"\","+k+",\"respond\")");
			}
		}
	}
}


scCommentViewWdg.prototype.formClosing = function(pArg1, pArg2, pArg3, pCommand, pArgSup) {
	var vNode = scPaLib.findNode("des:textarea.editformArea", document);
	if (vNode && !confirm(scCommentMgr.strings.notSynchronizedWarning)) return;

	switch (pCommand) {
		case "create" :
			scCommentMgr.controller.createThread(pArg1);
			scCommentLib.addHtmlClass(scCommentMgr.rootNode,"commentCreation");
			break;

		case "delete" :
			scCommentMgr.controller.deleteComment(pArg1,pArg2, pArg3);
			scCommentLib.removeHtmlClass(scCommentMgr.rootNode,"commentCreation");
			break;

		case "update" :
			scCommentMgr.controller.updateComment(pArg1, pArg2, pArg3);
			scCommentLib.removeHtmlClass(scCommentMgr.rootNode,"commentCreation");
			break;

		case "valid" :
			scCommentMgr.controller.closeThread(pArg1, pArg2);
			scCommentLib.removeHtmlClass(scCommentMgr.rootNode,"commentCreation");
			break;

		case "respond" :
			scCommentMgr.controller.respondThread(pArg1, pArg2, pArg3);
			scCommentLib.removeHtmlClass(scCommentMgr.rootNode,"commentCreation");
			break;
			
		case "onOff" :
			scCommentMgr.controller.toggleCommentMode();
			scCommentLib.removeHtmlClass(scCommentMgr.rootNode,"commentCreation");
			break;
	}

}
scCommentViewWdg.prototype.exitWindow = function() {
	if (scCommentMgr.controller.fCommentMode && scPaLib.findNode("des:textarea.editformArea", document)) return scCommentMgr.strings.notSynchronizedWarning;
}



scCommentViewWdg.prototype.updateCommentControl = function(pOripath, pIndex){
	var vDblClick = function(event) {
		if(scCommentMgr.controller.fCommentMode) scCommentMgr.view.formClosing(pIndex, null, null, "create");
		event = event || window.event;
		event.cancelBubble = true;
		if (event.stopPropagation) event.stopPropagation();
	};
	var vMouseOver = function(event) {
		var event = event || window.event;
		if (scCommentMgr.controller.fCommentMode) {
			scCommentMgr.view.resetHover();
			var vNode =  event.srcElement || event.toElement || event.target;
			vNode = scPaLib.findNode("can:.scCommentable", vNode);
			scCommentLib.addHtmlClass(vNode, "hover");
		}
		event.cancelBubble = true;
		if (event.stopPropagation)event.stopPropagation();
	};
	var vMouseOut =  function(event) {
		scCommentMgr.view.resetHover();
		event = event || window.event;
		event.cancelBubble = true;
		if (event.stopPropagation)event.stopPropagation();
	};
	
	if(pOripath.fPerms.Create){
		scCommentLib.addHtmlClass(pOripath.fNode, "scCommentable");
		if (pOripath.fNode.addEventListener){
			pOripath.fNode.addEventListener("dblclick", vDblClick);
			pOripath.fNode.addEventListener("mouseover", vMouseOver);
			pOripath.fNode.addEventListener("mouseout", vMouseOut);
		}
		else{
			pOripath.fNode.attachEvent("ondblclick", vDblClick);
			pOripath.fNode.attachEvent("onmouseover", vMouseOver);
			pOripath.fNode.attachEvent("onmouseout", vMouseOut);
		}
	}
	else{
		if (pOripath.fNode.removeEventListener){
			pOripath.fNode.removeEventListener("dblclick", vDblClick);
			pOripath.fNode.removeEventListener("mouseover", vMouseOver);
			pOripath.fNode.removeEventListener("mouseout", vMouseOut);
		}
		else{
			pOripath.fNode.detachEvent("ondblclick", vDblClick);
			pOripath.fNode.detachEvent("onmouseover", vMouseOver);
			pOripath.fNode.detachEvent("onmouseout", vMouseOut);
		}
		scCommentLib.removeHtmlClass(pOripath.fNode, "scCommentable");
		scCommentMgr.view.resetHover();
	}
	if("scSiLib" in window) scSiLib.fireResizedNode(scCommentMgr.rootNode);
}


scCommentViewWdg.prototype.removeCommentControls = function() {
	if("scSiLib" in window) scSiLib.fireResizedNode(scCommentMgr.rootNode);
}


scCommentViewWdg.prototype.resetHover = function() {
	var vSelectedNodes = scPaLib.findNodes("des:.hover", document);
	for (var i = 0; i < vSelectedNodes.length; i++) scCommentLib.removeHtmlClass(vSelectedNodes[i], "hover");
}


scCommentFlowWdg = function(){
	scCommentViewWdg.call(this);
}
scCommentFlowWdg.prototype = new scCommentViewWdg();
scCommentFlowWdg.prototype.constructor = scCommentViewWdg;


scCommentFlowWdg.prototype.init = function(){
	var vToolBar = scPaLib.findNode("des:.scCommentToolBar", scCommentMgr.toolBarNode);
	if(vToolBar){
		scCommentMgr.toolBarNode = vToolBar;
		var vButton = this.getToggleButton();
		vButton.onclick = function(){ scCommentMgr.controller.toggleCommentMode();};
	}
	else{
		scCommentMgr.toolBarNode =  scDynUiMgr.addElement("div", scCommentMgr.toolBarNode, "scCommentToolBar");
		var vCommentBtnDiv = scDynUiMgr.addElement("div", scCommentMgr.toolBarNode, "activationCommentDiv");
		scCommentLib.addButton(vCommentBtnDiv, "turnOn", null, scCommentMgr.strings.turnOnLabel, function(){ scCommentMgr.controller.toggleCommentMode();});
	}
}


scCommentFlowWdg.prototype.getToggleButton = function(){
	return scPaLib.findNode("des:button.turnOff", scCommentMgr.toolBarNode) || scPaLib.findNode("des:button.turnOn", scCommentMgr.toolBarNode);
}


scCommentFlowWdg.prototype.removeThreads = function() {

	if (this.fThreadList) for (var i = 0; i<this.fThreadList.length; i++) scCommentLib.addHtmlClass(this.fThreadList[i].fNode, "scDeletedComment");
	if("scSiLib" in window) scSiLib.fireResizedNode(scCommentMgr.rootNode);
}


scCommentFlowWdg.prototype.updateThreads = function() {
	var vThreadsAdded = false;
	for (var i = 0; i < this.fThreadList.length; i++) {
		var vOripath = this.fThreadList[i].fAnchorOripath

		if(!vOripath.fCommentContainerNode){
			if (scCommentLib.getParam(scCommentMgr.params.insertFirst, vOripath.fNode)){ //case threads are inserted between the element and its children
				vOripath.fCommentContainerNode = scDynUiMgr.addElement("div", vOripath.fNode, "commentContainer", vOripath.fNode.firstElementChild);
			}
			else if (scCommentLib.getParam(scCommentMgr.params.insertSecond, vOripath.fNode)){ //case threads are inserted between the element and its children
				if (vOripath.fNode.childNodes.length > 1) //oripath is set on the parent of an hx
					vOripath.fCommentContainerNode = scDynUiMgr.addElement("div", vOripath.fNode, "commentContainer", vOripath.fNode.children[1]);				
				else  vOripath.fCommentContainerNode = scDynUiMgr.addElement("div", vOripath.fNode, "commentContainer");
			}
			else //standard case, threads are inserted between the element and its next element sibling
				vOripath.fCommentContainerNode = scDynUiMgr.addElement("div", vOripath.fNode, "commentContainer");
		}
		if(!vOripath.fCommentContainerNode.ondblclick){ //events init
			vOripath.fCommentContainerNode.ondblclick = function(event) { //dlb click event interception
				event = event || window.event;
				event.cancelBubble = true;
				if (event.stopPropagation) event.stopPropagation();
			}
			vOripath.fCommentContainerNode.onmouseover = function(event) { //add a class on hover
				scCommentMgr.view.resetHover();
				scCommentLib.addHtmlClass(scPaLib.findNode("anc:.scCommentable", this), "hover");
				event = event || window.event;
				event.cancelBubble = true;
				if (event.stopPropagation) event.stopPropagation();
			}
			vOripath.fCommentContainerNode.onmouseout = function(event) {//delete a class on mouse out
				scCommentMgr.view.resetHover();
				event = event || window.event;
				event.cancelBubble = true;
				if (event.stopPropagation) event.stopPropagation();
			}
		}
			
		if(this.fThreadList[i].fNode){
			if(!this.fThreadList[i].fThreadModel || this.fThreadList[i].fThreadModel.status == "toRebuild"){
				this.fThreadList[i].fNode.parentElement.removeChild(this.fThreadList[i].fNode);
				if(! this.fThreadList[i].fThreadModel){
					this.fThreadList.splice(i, 1);
					i--;
					scCommentMgr.listeners.fire("onThreadUpdate", vOripath.fCommentContainerNode);
					continue;
				}
				else {
					this.fThreadList[i].fThreadModel.status = null;
					this.fThreadList[i].fNode = null;
				}
			}
		}
		
		if(this.fThreadList[i].fNode) scCommentLib.removeHtmlClass(this.fThreadList[i].fNode, "scDeletedComment");
		else{ //create the thread at the right position
			var j = i + 1;
			var vFollower = null;

			while(j < this.fThreadList.length && this.fThreadList[j].fAnchorOripath == vOripath && !this.fThreadList[j].fNode) j++;
			if(j < this.fThreadList.length && this.fThreadList[j].fAnchorOripath == vOripath ) vFollower = this.fThreadList[j].fNode;			
			this.fThreadList[i].fNode = scDynUiMgr.addElement("div", vOripath.fCommentContainerNode, "thread", vFollower);
			this.buildThread(scCommentMgr.view.fThreadList[i]);
			scCommentMgr.listeners.fire("onThreadUpdate", vOripath.fCommentContainerNode);
			vThreadsAdded = true;
		}
		scCommentMgr.listeners.fire("onThreadBuilt", vOripath.fCommentContainerNode);
	}
	if (vThreadsAdded) scCommentMgr.listeners.fire("onAllThreadsBuilt", scCommentMgr.rootNode);

	for(var i = 0 ; i < scCommentMgr.controller.fControlOriPathArray.length ; i++){
		var vOripath = scCommentMgr.controller.fControlOriPathArray[i];
		if(vOripath.fCommentContainerNode && !vOripath.fCommentContainerNode.childNodes.length) 
			scCommentLib.removeHtmlClass(vOripath.fNode, "scCommented");
	}
	this.addNumberThread();
	if("scSiLib" in window) scSiLib.fireResizedNode(scCommentMgr.rootNode);
}





scCommentFlowWdg.prototype.addNumberThread = function(){
	var vTotalNumber = this.fThreadList.length;
	var vTotalOpenedNumber = 0;
	for(var i = 0 ; i < vTotalNumber ; i++){
		if(!this.fThreadList[i].fThreadModel.threadClosed) vTotalOpenedNumber++;
	}
	var vButton = this.getToggleButton();
	var vCounter = scPaLib.findNode("nsi:.globalInfoBullet",vButton);
	if(vTotalNumber){
		if(!vCounter) vCounter = scDynUiMgr.addElement("span", vButton.parentNode, "globalInfoBullet");	
		if(vCounter.textContent != null) vCounter.textContent = new String(vTotalOpenedNumber+"/"+vTotalNumber);
		else vCounter.innerText = new String(vTotalOpenedNumber+"/"+vTotalNumber);
		var vDesc =  scCommentLib.buildString(scCommentMgr.strings.openedThreadsLabel, vTotalOpenedNumber, vTotalNumber);
		vCounter.setAttribute("title",vDesc);
		
		var vDescNode = scDynUiMgr.addElement("span", vCounter, "globalInfoBulletDesc");
		if(vDescNode.textContent != null) vDescNode.textContent = vDesc;
		else vDescNode.innerText = vDesc
	}
	else{
		if(vCounter) vCounter.parentNode.removeChild(vCounter);
	}
}



scCommentMarginWdg = function(){
	scCommentViewWdg.call(this);
}

scCommentMarginWdg.params = {
	marginSide: "left"
};

scCommentMarginWdg.prototype = new scCommentViewWdg();
scCommentMarginWdg.prototype.constructor = scCommentMarginWdg;

scCommentMarginWdg.prototype.init = function(){
	var vSelf = this;
	
	this.fMode = "content";
	this.fCurrentThreadIndex = 0;
	scCommentMgr.rootNode.setAttribute('scc-marginSide', scCommentMarginWdg.params.marginSide);
	
	this.fMargin = scDynUiMgr.addElement("div", scCommentMgr.rootNode, "commentMargin", scCommentMgr.rootNode.firstChild);
	
	scCommentMgr.toolBarNode = scDynUiMgr.addElement("div", scCommentMgr.toolBarNode, "scCommentToolBar");
	var vToolbarDiv = scDynUiMgr.addElement("div", scCommentMgr.toolBarNode);
	this.fOnOffBtn = scCommentLib.addButton(vToolbarDiv, "scCommentOnOffBtn", null, scCommentMgr.strings.turnOnLabel, function() {
		scCommentMgr.controller.toggleCommentMode();
	});
	
	this.fModeBtn = scCommentLib.addButton(vToolbarDiv, "scCommentModeBtn", null, scCommentMgr.strings.commentsMode, function() {
		vSelf.fMode = vSelf.fMode == "content" ? "comments" : "content";
		vSelf.updateMode();
	});
	
	this.fPreviousBtn = scCommentLib.addButton(vToolbarDiv, "scCommentPrevBtn", null, scCommentMgr.strings.prevComment, function() {
		vSelf.updateCurrentThread(vSelf.fCurrentThreadIndex-1);
	});
	
	this.fNextBtn = scCommentLib.addButton(vToolbarDiv, "scCommentNextBtn", null, scCommentMgr.strings.nextComment, function() {
		vSelf.updateCurrentThread(vSelf.fCurrentThreadIndex+1);
	});

	var vResizeTimeout;
	scCommentLib.addEventListener(window, 'resize', function() {
		if (!vResizeTimeout) {
			vResizeTimeout = setTimeout(function() {
				vSelf.updateThreadsPosition();
				vResizeTimeout = null;
			}, 200);
		}
	});
	

	if (document.fonts) {
		document.fonts.addEventListener('loadingdone', function() {
			vSelf.updateThreadsPosition();
		});
	} else setTimeout(function() {
		vSelf.updateThreadsPosition();
	}, 500)

}



scCommentMarginWdg.prototype.getToggleButton = function() {
	return this.fOnOffBtn;
}



scCommentMarginWdg.prototype.updateThreads = function() {
	var vSelf = this,
		vOriPathArray = scCommentMgr.controller.getControlOriPathArray(),
		vPrevContainer,
		vEditThreadIndex = -1;

	for (var i = 0; i < this.fThreadList.length; i++) {
		var vThread = this.fThreadList[i],
			vOripath = vThread.fAnchorOripath,
			vContainer = vOripath.fCommentContainerNode;
		
		if (!vContainer) {
			vContainer = (function (pOripath, pPrevContainer) {
				var vContainer = pOripath.fCommentContainerNode = scDynUiMgr.addElement("div", vSelf.fMargin, "commentContainer", pPrevContainer ? pPrevContainer.nextSibling : vSelf.fMargin.firstChild);
				var vMarker = pOripath.fMarkerNode = scDynUiMgr.addElement("div", vSelf.fMargin, "scCommentMarker");

				vContainer.fHighlight = function(pEvent) {
					for (var k=0; k<vSelf.fThreadList.length; k++) {
						vSelf.fThreadList[k].fAnchorOripath.fCommentContainerNode.fLowlight(pEvent);
					}
					if (!pEvent || vSelf.fMode == "content") {
						scCommentLib.addHtmlClass(vContainer, 'scHighlight');
						scCommentLib.addHtmlClass(vMarker, 'scHighlight');
						scCommentLib.addHtmlClass(pOripath.fNode, 'scHighlight');
						if (pEvent) scCommentLib.stopPropagation(pEvent);
					}
				}
				vContainer.fLowlight = function(pEvent) {
					if (!pEvent || vSelf.fMode == "content") {
						scCommentLib.removeHtmlClass(vContainer, 'scHighlight');
						scCommentLib.removeHtmlClass(vMarker, 'scHighlight');
						scCommentLib.removeHtmlClass(pOripath.fNode, 'scHighlight');
						if (pEvent && pEvent.type == "mouseout") scCommentLib.stopPropagation(pEvent);
					}
				}
				vContainer.fSelectThread = function(pEvent) {
					if (vSelf.fMode == "comments") {
						for (var j = 0; j < vSelf.fThreadList.length; j++) {
							var vThread = vSelf.fThreadList[j];
							if (!vThread.fCurrent && vThread.fNode.contains(pEvent.target)) {
								vSelf.updateCurrentThread(j);
							}
						}
					}
				}
				scCommentLib.addEventListener(pOripath.fNode, 'mouseover', vContainer.fHighlight);
				scCommentLib.addEventListener(vContainer, 'mouseover', vContainer.fHighlight);
				scCommentLib.addEventListener(pOripath.fNode, 'mouseout', vContainer.fLowlight);
				scCommentLib.addEventListener(vContainer, 'mouseout', vContainer.fLowlight);
				scCommentLib.addEventListener(vContainer, 'click', vContainer.fSelectThread);
				return vContainer;
				
			})(vOripath, vPrevContainer)
		}

		if(vThread.fNode){
			if(!vThread.fThreadModel || vThread.fThreadModel.status == "toRebuild"){
				vContainer.removeChild(vThread.fNode);
				if(! vThread.fThreadModel){
					this.fThreadList.splice(i, 1);
					i--;
					if(!vContainer.childNodes.length) this.unbindComment(vOripath);
					continue;
				}
				else {
					vThread.fThreadModel.status = null;
					vThread.fNode = null;
				}
			}
		}

		if(vThread.fNode) {
			scCommentLib.removeHtmlClass(vThread.fNode, "scDeletedComment");
			this.updateThreadPosition(vThread);
		} else{ //create the thread at the right position
			var j = i + 1;
			var vFollower = null;

			while(j < this.fThreadList.length && this.fThreadList[j].fAnchorOripath == vOripath && !this.fThreadList[j].fNode) j++;
			if(j < this.fThreadList.length && this.fThreadList[j].fAnchorOripath == vOripath ) vFollower = this.fThreadList[j].fNode;			
			vThread.fNode = scDynUiMgr.addElement("div", vOripath.fCommentContainerNode, "thread", vFollower);

			this.updateThreadPosition(vThread);
			this.buildThread(vThread);
			this.updateThreadPosition(vThread);
		}

		if (vEditThreadIndex == -1) {
			for (var k=0; k<vThread.fThreadModel.comments.length; k++) {
				if (vThread.fThreadModel.comments[k].fEdit) {
					vEditThreadIndex = i;
					break;
				}
			}
		}
				
		vPrevContainer = vContainer;
	}

	for(var i = 0 ; i < scCommentMgr.controller.fControlOriPathArray.length ; i++){
		var vOripath = scCommentMgr.controller.fControlOriPathArray[i];
		if(vOripath.fCommentContainerNode && !vOripath.fCommentContainerNode.childNodes.length) { 
			this.unbindComment(vOripath);
		}
	}

	if (this.fMode == "comments") {
		if (vEditThreadIndex != -1) this.updateCurrentThread(vEditThreadIndex);
		else {

			var vHasCurrent = false;
			for (var i=0; i<this.fThreadList.length; i++) {
				if (this.fThreadList[i].fCurrent) {
					this.updateCurrentThread(i);
					vHasCurrent = true;
					break;
				}
			}
			if (!vHasCurrent) this.updateCurrentThread(this.fCurrentThreadIndex);
		}
	}
}

scCommentMarginWdg.prototype.unbindComment = function(pOriPath) {
		var vContainer = pOriPath.fCommentContainerNode,
			vMarker = pOriPath.fMarkerNode;
			
		scCommentLib.removeHtmlClass(pOriPath.fNode, "scCommented");
		vContainer.fLowlight();		
		vContainer.parentNode.removeChild(vContainer);
		vMarker.parentNode.removeChild(vMarker);
		scCommentLib.removeEventListener(pOriPath.fNode, 'mouseover', vContainer.fHighlight);
		scCommentLib.removeEventListener(vContainer, 'mouseover', vContainer.fHighlight);
		scCommentLib.removeEventListener(pOriPath.fNode, 'mouseout', vContainer.fLowlight);
		scCommentLib.removeEventListener(vContainer, 'mouseout', vContainer.fLowlight);
		scCommentLib.removeEventListener(vContainer, 'click', vContainer.fSelectThread);

		pOriPath.fCommentContainerNode = pOriPath.fMarkerNode = null;
}


scCommentMarginWdg.prototype.removeThreads = function() { }


scCommentMarginWdg.prototype.updateThreadsPosition = function() {
	if (this.fThreadList) for (var i = 0; i < this.fThreadList.length; i++) {
		this.updateThreadPosition(this.fThreadList[i], i);	
	};
}


scCommentMarginWdg.prototype.updateThreadPosition = function (pThread) {
	var vOripath = pThread.fAnchorOripath,
		vMarker = vOripath.fMarkerNode,
		vContainer = vOripath.fCommentContainerNode;
	
	if (this.fMode == "content" && pThread.fNode == vContainer.firstChild) {

		

		vContainer.style.marginTop = "";
		

		var vNodeTop = scSiLib.getOffsetTop(vOripath.fNode, scCommentMgr.rootNode),
			vContainerTop = scSiLib.getOffsetTop(vContainer, scCommentMgr.rootNode);
		
		var vDelta = 0;
		if (vContainerTop < vNodeTop) {
			vDelta = vNodeTop - vContainerTop;
			vContainer.style.marginTop = vDelta + "px";
		}
		

		vContainerTop = scSiLib.getOffsetTop(vContainer, scCommentMgr.rootNode);
		if (vContainerTop < vNodeTop) {

			vContainer.style.marginTop = vDelta + (vNodeTop - vContainerTop) + "px";
			vContainerTop += (vNodeTop - vContainerTop);
		}
	

		var vContainerCenter = vContainerTop + vContainer.offsetHeight / 2,
			vContainerBottom = vContainerTop + vContainer.offsetHeight,
			vNodeBottom = vNodeTop + vOripath.fNode.offsetHeight,
			vNodeCenter = vNodeTop + vOripath.fNode.offsetHeight / 2,
			vNodeLeft = scCommentLib.getOffsetLeft(vOripath.fNode, scCommentMgr.rootNode),
			vMarginLeft = scCommentLib.getOffsetLeft(this.fMargin, scCommentMgr.rootNode);
		
		if (scCommentMarginWdg.params.marginSide == "left") {
			vMarker.style.width = vNodeLeft - (vMarginLeft + this.fMargin.offsetWidth) + "px";
		} else {
			vMarker.style.width = vMarginLeft - (vNodeLeft + vOripath.fNode.offsetWidth) + "px";
		}
		
		if (vContainerBottom < vNodeBottom) {
			vMarker.style.top = vContainerCenter + "px";
			vMarker.style.height = 0;
		} else if (vContainerTop < vNodeCenter && vNodeBottom < vContainerBottom) {
			vMarker.style.top = vNodeCenter + "px";
			vMarker.style.height = 0;
		} else {
			vMarker.style.top = vNodeCenter + "px";
			vMarker.style.height = (vContainerCenter - vNodeCenter) + "px";
		}
	} else {


		if (pThread.fNode == vContainer.firstChild) vContainer.style.marginTop = "";
		
		if (pThread == this.fThreadList[this.fCurrentThreadIndex]) {
			var vFirstContainer = this.fThreadList[0].fAnchorOripath.fCommentContainerNode,
				vViewHeight = Math.min(document.documentElement.clientHeight, scCommentMgr.rootNode.offsetHeight),
				vNodeHeight = vOripath.fNode.offsetHeight,
				vNodeTop = scSiLib.getOffsetTop(vOripath.fNode, scCommentMgr.rootNode),
				vThreadTop = scSiLib.getOffsetTop(pThread.fNode, this.fMargin),
				vThreadHeight = pThread.fNode.offsetHeight,
				vMarginHeight = this.fMargin.clientHeight,
				vScrollTop = vNodeTop;
			
			if (vNodeHeight < vViewHeight) vScrollTop -= (vViewHeight - vNodeHeight) / 2;
			window.scrollTo(0, vScrollTop);
			vFirstContainer.style.marginTop = ((vViewHeight - vThreadHeight) / 2 - vThreadTop) + 'px';
		}
		
	}
}

scCommentMarginWdg.prototype.updateCommentControl = scCommentFlowWdg.prototype.updateCommentControl;
scCommentMarginWdg.prototype.resetHover = scCommentFlowWdg.prototype.resetHover;


scCommentMarginWdg.prototype.updateMode = function() {
	scCommentMgr.rootNode.setAttribute("scc-mode", this.fMode);
	if (this.fMode == "content") {
		this.updateThreadsPosition();
		this.fModeBtn.title = this.fModeBtn.value = scCommentMgr.strings.commentsMode;
	} else {
		this.updateCurrentThread(this.fCurrentThreadIndex);
		this.fModeBtn.title = this.fModeBtn.value = scCommentMgr.strings.contentMode;
	}
}


scCommentMarginWdg.prototype.updateCurrentThread = function(pNewCurrentThreadIndex) {
	if (!this.fThreadList || !this.fThreadList.length) {
		scCommentLib.addHtmlClass(this.fPreviousBtn, "scOff");
		scCommentLib.addHtmlClass(this.fNextBtn, "scOff");
		return;
	}
	if (pNewCurrentThreadIndex < 0) return;
	while (pNewCurrentThreadIndex >= this.fThreadList.length) pNewCurrentThreadIndex--;
	
	for (var i=0; i<this.fThreadList.length; i++) {
		var vThread = this.fThreadList[i];
		if (vThread.fCurrent) {
			vThread.fCurrent = false;
			var vOriPath = vThread.fAnchorOripath;
			scCommentLib.removeHtmlClass(vThread.fNode, "current");
			scCommentLib.removeHtmlClass(vOriPath.fCommentContainerNode, "scHighlight");
			scCommentLib.removeHtmlClass(vOriPath.fMarkerNode, 'scHighlight');
			scCommentLib.removeHtmlClass(vOriPath.fNode, "scHighlight");
		}
	}

	if (pNewCurrentThreadIndex == 0) scCommentLib.addHtmlClass(this.fPreviousBtn, "scOff");
	else scCommentLib.removeHtmlClass(this.fPreviousBtn, "scOff");
		
	if (pNewCurrentThreadIndex == this.fThreadList.length - 1) scCommentLib.addHtmlClass(this.fNextBtn, "scOff");
	else scCommentLib.removeHtmlClass(this.fNextBtn, "scOff");
	
	this.fCurrentThreadIndex = pNewCurrentThreadIndex;
	vThread = this.fThreadList[this.fCurrentThreadIndex];
	if (vThread) {
		vThread.fCurrent = true;
		var vOriPath = vThread.fAnchorOripath;
		scCommentLib.addHtmlClass(vThread.fNode, "current");
		scCommentLib.addHtmlClass(vOriPath.fCommentContainerNode, "scHighlight");
		scCommentLib.addHtmlClass(vOriPath.fMarkerNode, 'scHighlight');
		scCommentLib.addHtmlClass(vOriPath.fNode, "scHighlight");
	}
	
	this.updateThreadsPosition();
}