<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:rsc="scenari.eu:remote" xmlns:java="http://xml.apache.org/xslt/java" xmlns:of="scpf.org:office" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="rsc java of sp " >

<xsl:param name="vSrcNode"/>

<xsl:template match="text()|@*"/>
<xsl:template match="*[@sc:refUri]">
<attrRef nm="?" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template match="/sc:item">
<xsl:apply-templates select="rsc:remoteVideo"/>
</xsl:template>

<xsl:template match="sc:item/rsc:remoteVideo">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="of:videoM"><xsl:value-of select="sp:title"/></xsl:for-each></title>
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="rsc:remoteVideo/sc:location[not(text())]">
<cPbs>
<pb typ="Error" cd="emptyUrl" msg="{formatStr('Le champ &apos;&apos;%s&apos;&apos; est vide.', 'URL de la ressource vidéo distante')}"/>
</cPbs>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:videoM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
				
				
					
					
				
				
					
					<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:videoM/sp:accessibility/sp:subTitles/sp:subTitle[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_videoM:accessibility:subTitles:subTitle:"/>
</xsl:template>
				
			
			
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:videoM/sp:accessibility/sp:audioDesc[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_videoM:accessibility:audioDesc:"/>
</xsl:template>
			
			
				
				
			
			
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:videoM/sp:accessibility/sp:altVideo[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_videoM:accessibility:altVideo:"/>
</xsl:template>
			
		
			
			
		
		
			
			
				
			
			
				
			
		
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='url'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:transcript]">
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:transcript]">
<xsl:apply-templates/>
</xsl:template>
			
			
			
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:transcript">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:urlM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
		
			
			
				
				
			
			
				
				
			
			
				
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:langM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:txtM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
		
			
			
				
			
			
				
			
			
				
				
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role=''][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='head'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='total'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				
				
				
			
			
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role='layout'][@role=''][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='img'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:extBlockTag:img"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='anim'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:extBlockTag:anim"/>
</xsl:template>
		
		
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='def'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:uLinkTag:def"/>
<xsl:apply-templates/>
</xsl:template>
			
			
				
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:uLinkTag:ref#ref"/>
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='url'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:inlineImgTag:ico"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:txt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>


</xsl:stylesheet>