<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core"
	xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" 
	xmlns:of="scpf.org:office" xmlns:xalan="http://xml.apache.org/xalan" xmlns:sfm="http://www.utc.fr/ics/scenari/v3/filemeta"
	exclude-result-prefixes="xalan">

	<xsl:output encoding="UTF-8" indent="yes" method="xml"/>

	<!-- Migration des uLink des url vers des phrase -->
	<xsl:template match="sc:uLink[not(@role) or @role='url']">
		<sc:phrase role="url"><of:urlM><sp:url><xsl:value-of select="@url" /></sp:url></of:urlM><xsl:apply-templates /></sc:phrase>
	</xsl:template>

	<!-- Migration des metas des binaries -->
	<xsl:template match="of:animM">
		<xsl:choose>
			<xsl:when test="parent::sfm:mp3 or parent::sfm:oga or parent::sfm:ogg or parent::sfm:m4a">
				<of:audioM>
		        	<xsl:call-template name="alt"/>
		        </of:audioM>
			</xsl:when>
			<xsl:when test="parent::sfm:mp4 or parent::sfm:webM or parent::sfm:ogV">
				<of:videoM>
		        	<xsl:call-template name="alt"/>
		        </of:videoM>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates />
			</xsl:otherwise>
		</xsl:choose>        
    </xsl:template>
    <xsl:template name="alt">
    	<xsl:if test="sp:title">
    		<xsl:copy-of select="sp:title"/>
        </xsl:if>
        <xsl:if test="sp:desc">
        	<sp:accessibility>
				<sp:transcript>
					<of:transcript>
						<xsl:apply-templates select="sp:desc/*/*" />
					</of:transcript>						
				</sp:transcript>
			</sp:accessibility>            	
        </xsl:if>
        <xsl:apply-templates select="sp:alt" />
    </xsl:template>

	<xsl:template match="node() | @*">
		<xsl:copy>
			<xsl:apply-templates select="node() | @*" />
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
